
# This file was generated by Hermes Parser Generator on Wed Dec 19 05:52:48 2018
# 
# Hermes command: hermes generate wdl/versions/draft-3/parsers/grammar.hgr --language=python --name=draft_3 --header --directory wdl_parser
# Run from: .. (relative to this file)
# Hermes version: hermes-parser 2.0rc6
# 
# !!! DO NOT CHANGE THIS FILE DIRECTLY !!!
# 
# If you wish to change something in this file, either change the grammar and
# re-generate this file, or change the templates in Hermes and regenerate.
# See the Hermes repository: http://github.com/scottfrazer/hermes
import sys
import os
import re
import base64
import argparse
from collections import OrderedDict
# Common Code #
def parse_tree_string(parsetree, indent=None, b64_source=True, indent_level=0, debug=False):
    indent_str = (' ' * indent * indent_level) if indent else ''
    if isinstance(parsetree, ParseTree):
        children = [parse_tree_string(child, indent, b64_source, indent_level+1, debug) for child in parsetree.children]
        debug_str = parsetree.debug_str() if debug else ''
        if indent is None or len(children) == 0:
            return '{0}({1}: {2}{3})'.format(indent_str, parsetree.nonterminal, debug_str, ', '.join(children))
        else:
            return '{0}({1}:{2}\n{3}\n{4})'.format(
                indent_str,
                parsetree.nonterminal,
                debug_str,
                ',\n'.join(children),
                indent_str
            )
    elif isinstance(parsetree, Terminal):
        return indent_str + parsetree.dumps(b64_source=b64_source)
def ast_string(ast, indent=None, b64_source=True, indent_level=0):
    indent_str = (' ' * indent * indent_level) if indent else ''
    next_indent_str = (' ' * indent * (indent_level+1)) if indent else ''
    if isinstance(ast, Ast):
        children = OrderedDict([(k, ast_string(v, indent, b64_source, indent_level+1)) for k, v in ast.attributes.items()])
        if indent is None:
            return '({0}: {1})'.format(
                ast.name,
                ', '.join('{0}={1}'.format(k, v) for k, v in children.items())
            )
        else:
            return '({0}:\n{1}\n{2})'.format(
                ast.name,
                ',\n'.join(['{0}{1}={2}'.format(next_indent_str, k, v) for k, v in children.items()]),
                indent_str
            )
    elif isinstance(ast, list):
        children = [ast_string(element, indent, b64_source, indent_level+1) for element in ast]
        if indent is None or len(children) == 0:
            return '[{0}]'.format(', '.join(children))
        else:
            return '[\n{1}\n{0}]'.format(
                indent_str,
                ',\n'.join(['{0}{1}'.format(next_indent_str, child) for child in children]),
            )
    elif isinstance(ast, Terminal):
        return ast.dumps(b64_source=b64_source)
class Terminal:
  def __init__(self, id, str, source_string, resource, line, col):
      self.__dict__.update(locals())
  def getId(self):
      return self.id
  def ast(self):
      return self
  def dumps(self, b64_source=True, **kwargs):
      source_string = base64.b64encode(self.source_string.encode('utf-8')).decode('utf-8') if b64_source else self.source_string
      return '<{resource}:{line}:{col} {terminal} "{source}">'.format(
          resource=self.resource,
          line=self.line,
          col=self.col,
          terminal=self.str,
          source=source_string
      )
  def __str__(self):
      return self.dumps()
class NonTerminal():
  def __init__(self, id, str):
    self.__dict__.update(locals())
    self.list = False
  def __str__(self):
    return self.str
class AstTransform:
  pass
class AstTransformSubstitution(AstTransform):
  def __init__(self, idx):
    self.__dict__.update(locals())
  def __repr__(self):
    return '$' + str(self.idx)
  def __str__(self):
    return self.__repr__()
class AstTransformNodeCreator(AstTransform):
  def __init__( self, name, parameters ):
    self.__dict__.update(locals())
  def __repr__( self ):
    return self.name + '( ' + ', '.join(['%s=$%s' % (k,str(v)) for k,v in self.parameters.items()]) + ' )'
  def __str__(self):
    return self.__repr__()
class AstList(list):
  def ast(self):
      retval = []
      for ast in self:
          retval.append(ast.ast())
      return retval
  def dumps(self, indent=None, b64_source=True):
      args = locals()
      del args['self']
      return ast_string(self, **args)
class ParseTree():
  def __init__(self, nonterminal):
      self.__dict__.update(locals())
      self.children = []
      self.astTransform = None
      self.isExpr = False
      self.isNud = False
      self.isPrefix = False
      self.isInfix = False
      self.nudMorphemeCount = 0
      self.isExprNud = False # true for rules like _expr := {_expr} + {...}
      self.list_separator_id = None
      self.list = False
  def debug_str(self):
      from copy import deepcopy
      def h(v):
          if v == False or v is None:
              return str(v)
          from xtermcolor import colorize
          return colorize(str(v), ansi=190)
      d = deepcopy(self.__dict__)
      for key in ['self', 'nonterminal', 'children']:
          del d[key]
      f = {k: v for k, v in d.items() if v != False and v is not None}
      return ' [{}]'.format(', '.join(['{}={}'.format(k,h(v)) for k,v in f.items()]))
  def add(self, tree):
      self.children.append( tree )
  def is_compound_nud(self):
      return isinstance(self.children[0], ParseTree) and \
             self.children[0].isNud and \
             not self.children[0].isPrefix and \
             not self.isExprNud and \
             not self.isInfix
  def ast(self):
      if self.list == True:
          r = AstList()
          if len(self.children) == 0:
              return r
          for child in self.children:
              if isinstance(child, Terminal) and self.list_separator_id is not None and child.id == self.list_separator_id:
                  continue
              r.append(child.ast())
          return r
      elif self.isExpr:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  if idx == '$':
                      child = self.children[0]
                  elif self.is_compound_nud():
                      if idx < self.children[0].nudMorphemeCount:
                          child = self.children[0].children[idx]
                      else:
                          index = idx - self.children[0].nudMorphemeCount + 1
                          child = self.children[index]
                  elif len(self.children) == 1 and not isinstance(self.children[0], ParseTree) and not isinstance(self.children[0], list):
                      return self.children[0]
                  else:
                      child = self.children[idx]
                  parameters[name] = child.ast()
              return Ast(self.astTransform.name, parameters)
      else:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  parameters[name] = self.children[idx].ast()
              return Ast(self.astTransform.name, parameters)
          elif len(self.children):
              return self.children[0].ast()
          else:
              return None
  def dumps(self, indent=None, b64_source=True, debug=False):
      args = locals()
      del args['self']
      return parse_tree_string(self, **args)
class Ast():
    def __init__(self, name, attributes):
        self.__dict__.update(locals())
    def attr(self, attr):
        return self.attributes[attr]
    def dumps(self, indent=None, b64_source=True):
        args = locals()
        del args['self']
        return ast_string(self, **args)
class SyntaxError(Exception):
    def __init__(self, message):
        self.__dict__.update(locals())
    def __str__(self):
        return self.message
class TokenStream(list):
    def __init__(self, arg=[]):
        super(TokenStream, self).__init__(arg)
        self.index = 0
    def advance(self):
        self.index += 1
        return self.current()
    def last(self):
        return self[-1]
    def current(self):
        try:
            return self[self.index]
        except IndexError:
            return None
class DefaultSyntaxErrorHandler:
    def __init__(self):
        self.errors = []
    def _error(self, string):
        error = SyntaxError(string)
        self.errors.append(error)
        return error
    def unexpected_eof(self):
        return self._error("Error: unexpected end of file")
    def excess_tokens(self):
        return self._error("Finished parsing without consuming all tokens.")
    def unexpected_symbol(self, nonterminal, actual_terminal, expected_terminals, rule):
        return self._error("Unexpected symbol (line {line}, col {col}) when parsing parse_{nt}.  Expected {expected}, got {actual}.".format(
            line=actual_terminal.line,
            col=actual_terminal.col,
            nt=nonterminal,
            expected=', '.join(expected_terminals),
            actual=actual_terminal
        ))
    def no_more_tokens(self, nonterminal, expected_terminal, last_terminal):
        return self._error("No more tokens.  Expecting " + expected_terminal)
    def invalid_terminal(self, nonterminal, invalid_terminal):
        return self._error("Invalid symbol ID: {} ({})".format(invalid_terminal.id, invalid_terminal.string))
    def unrecognized_token(self, string, line, col):
        lines = string.split('\n')
        bad_line = lines[line-1]
        return self._error('Unrecognized token on line {}, column {}:\n\n{}\n{}'.format(
            line, col, bad_line, ''.join([' ' for x in range(col-1)]) + '^'
        ))
    def missing_list_items(self, method, required, found, last):
        return self._error("List for {} requires {} items but only {} were found.".format(method, required, found))
    def missing_terminator(self, method, terminator, last):
        return self._error("List for "+method+" is missing a terminator")
class ParserContext:
  def __init__(self, tokens, errors):
    self.__dict__.update(locals())
    self.nonterminal_string = None
    self.rule_string = None
# Parser Code #
terminals = {
    0: 'lparen',
    1: 'as',
    2: 'float',
    3: 'scatter',
    4: 'slash',
    5: 'raw_command',
    6: 'cmd_part',
    7: 'parameter_meta',
    8: 'lbrace',
    9: 'equal',
    10: 'null',
    11: 'type_e',
    12: 'raw_cmd_start',
    13: 'call',
    14: 'double_equal',
    15: 'not_equal',
    16: 'lteq',
    17: 'raw_cmd_end',
    18: 'runtime',
    19: 'dot',
    20: 'import',
    21: 'expression_placeholder_end',
    22: 'double_pipe',
    23: 'rsquare',
    24: 'percent',
    25: 'output',
    26: 'else',
    27: 'then',
    28: 'e',
    29: 'input',
    30: 'workflow',
    31: 'struct',
    32: 'comma',
    33: 'quote',
    34: 'meta',
    35: 'type',
    36: 'alias',
    37: 'lt',
    38: 'cmd_attr_hint',
    39: 'colon',
    40: 'if',
    41: 'while',
    42: 'boolean',
    43: 'double_ampersand',
    44: 'fqn',
    45: 'plus',
    46: 'dash',
    47: 'asterisk',
    48: 'rparen',
    49: 'string',
    50: 'task',
    51: 'in',
    52: 'gteq',
    53: 'not',
    54: 'identifier',
    55: 'version_name',
    56: 'rbrace',
    57: 'gt',
    58: 'integer',
    59: 'version',
    60: 'lsquare',
    61: 'expression_placeholder_start',
    62: 'meta_value',
    63: 'object',
    64: 'qmark',
    'lparen': 0,
    'as': 1,
    'float': 2,
    'scatter': 3,
    'slash': 4,
    'raw_command': 5,
    'cmd_part': 6,
    'parameter_meta': 7,
    'lbrace': 8,
    'equal': 9,
    'null': 10,
    'type_e': 11,
    'raw_cmd_start': 12,
    'call': 13,
    'double_equal': 14,
    'not_equal': 15,
    'lteq': 16,
    'raw_cmd_end': 17,
    'runtime': 18,
    'dot': 19,
    'import': 20,
    'expression_placeholder_end': 21,
    'double_pipe': 22,
    'rsquare': 23,
    'percent': 24,
    'output': 25,
    'else': 26,
    'then': 27,
    'e': 28,
    'input': 29,
    'workflow': 30,
    'struct': 31,
    'comma': 32,
    'quote': 33,
    'meta': 34,
    'type': 35,
    'alias': 36,
    'lt': 37,
    'cmd_attr_hint': 38,
    'colon': 39,
    'if': 40,
    'while': 41,
    'boolean': 42,
    'double_ampersand': 43,
    'fqn': 44,
    'plus': 45,
    'dash': 46,
    'asterisk': 47,
    'rparen': 48,
    'string': 49,
    'task': 50,
    'in': 51,
    'gteq': 52,
    'not': 53,
    'identifier': 54,
    'version_name': 55,
    'rbrace': 56,
    'gt': 57,
    'integer': 58,
    'version': 59,
    'lsquare': 60,
    'expression_placeholder_start': 61,
    'meta_value': 62,
    'object': 63,
    'qmark': 64,
}
# table[nonterminal][terminal] = rule
table = [
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1, -1, -1],
    [-1, 19, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 14, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 42, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, 76, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 68, -1, 69, -1, -1, -1, 69, 69, -1, -1, 69, -1, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 69, -1, -1, -1, 69, -1, -1, -1, -1, 69, 69, -1, -1, -1, -1, 69, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 69, -1, 69, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, 71, -1, -1, -1, 71, 70, -1, -1, 71, -1, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, -1, -1, 71, -1, -1, -1, -1, 71, 71, -1, -1, -1, -1, 71, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, 71, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 36, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, 46, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, 48, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 49, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 72, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, 23, -1, 27, -1, -1, -1, 29, -1, -1, -1, -1, -1, -1, 26, -1, -1, -1, -1, -1, -1, 25, -1, -1, -1, 24, -1, -1, -1, -1, 28, 29, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 29, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, 44, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 58, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 75, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, 80, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 81, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 12, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, 32, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 47, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, 31, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 6, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 82, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [53, -1, 53, -1, -1, -1, -1, -1, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 53, -1, -1, -1, -1, 53, -1, -1, -1, -1, -1, -1, 53, -1, 53, -1, -1, 53, 53, -1, -1, -1, -1, -1, -1, 53, 53, -1, -1, -1, 53, -1, 53, -1, -1, 53, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 39, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, 52, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, 74, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, 16, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 43, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, 41, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, 63, -1, -1, -1, 66, -1, -1, -1, 60, -1, 59, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 65, -1, -1, -1, 64, -1, -1, -1, -1, 67, 60, -1, -1, -1, -1, 62, 61, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 77, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 56, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 56, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 56, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
]
nonterminal_first = {
    65: [61],
    66: [1],
    67: [49, 61],
    68: [54, 11, 35, -1],
    69: [54],
    70: [31, 50, 30, -1],
    71: [36],
    72: [41],
    73: [20, -1],
    74: [54, -1],
    75: [11, 35, 54],
    76: [7],
    77: [1, -1],
    78: [8, -1],
    79: [11, 35, 54],
    80: [18, 35, 54, 5, 7, 11, 25, -1, 29, 34],
    81: [2, 42, 10, 8, 58, -1, 60, 62, 33],
    82: [38],
    83: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    84: [38, -1],
    85: [3, 40, 41, 7, 11, 34, 13, 54, 25, -1, 29, 35],
    86: [61, 49, -1],
    87: [54, -1],
    88: [8],
    89: [9, -1],
    90: [13],
    91: [18, 35, 54, 5, 7, 11, 25, 29, 34],
    92: [11, 35, 54],
    93: [7],
    94: [30],
    95: [31],
    96: [54, 11, 35, -1],
    97: [1],
    98: [40],
    99: [0, 2, 40, 42, 46, 8, 45, 53, 54, 58, -1, 28, 60, 63, 33],
    100: [33],
    101: [3],
    102: [54, -1],
    103: [54, -1],
    104: [54],
    105: [0, 2, 40, 42, 46, 8, 45, 53, 54, 58, -1, 28, 60, 63, 33],
    106: [50],
    107: [33],
    108: [6, 61],
    109: [54],
    110: [54, 11, 35, -1],
    111: [5],
    112: [25],
    113: [36, -1],
    114: [59],
    115: [54, -1],
    116: [54],
    117: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    118: [31, 50, 30],
    119: [18],
    120: [9],
    121: [61, 6, -1],
    122: [42, 2, 62, 60, 33, 10, 58, 8],
    123: [8],
    124: [11, 35, 54],
    125: [1, -1],
    126: [59],
    127: [34],
    128: [29],
    129: [8],
    130: [54, 11, 35, -1],
    131: [54, 3, 40, 41, 7, 11, 25, 34, 29, 13, 35],
    132: [20],
    133: [34],
    134: [11, 35, 54],
}
nonterminal_follow = {
    65: [17, 61, 49, 33, 6],
    66: [36, 20, 30, 31, -1, 50],
    67: [61, 49, 33],
    68: [56],
    69: [56, 54],
    70: [-1],
    71: [36, 20, 30, 31, -1, 50],
    72: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    73: [31, -1, 50, 30],
    74: [56],
    75: [54, 56, 11, 35],
    76: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    77: [3, 40, 41, 7, 8, 11, 34, 13, 54, 56, 25, 29, 35],
    78: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    79: [3, 40, 5, 7, 41, 11, 34, 13, 18, 54, 56, 25, 29, 35],
    80: [56],
    81: [23],
    82: [0, 2, 38, 40, 42, 46, 8, 45, 53, 54, 58, 28, 60, 63, 33],
    83: [0, 2, 4, 3, 5, 7, 11, 8, 13, 14, 15, 16, 18, 19, 22, 21, 24, 23, 25, 26, 27, 28, 29, 32, 33, 35, 34, 37, 38, 39, 43, 46, 40, 42, 41, 45, 47, 48, 52, 53, 54, 57, 56, 58, 60, 63],
    84: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    85: [56],
    86: [33],
    87: [56],
    88: [3, 40, 5, 7, 41, 11, 34, 13, 18, 54, 56, 25, 29, 35],
    89: [54, 56, 11, 35],
    90: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    91: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    92: [23, 32, 54],
    93: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    94: [30, 31, -1, 50],
    95: [30, 31, -1, 50],
    96: [56],
    97: [3, 40, 41, 7, 8, 11, 34, 13, 54, 56, 25, 29, 35],
    98: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    99: [48, 23],
    100: [1, 54, 20, 56, 23, 30, 32, 31, -1, 50],
    101: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    102: [56],
    103: [56],
    104: [56, 32],
    105: [56],
    106: [30, 31, -1, 50],
    107: [0, 2, 4, 3, 5, 7, 11, 8, 13, 14, 15, 16, 18, 19, 22, 21, 24, 23, 25, 26, 27, 28, 29, 32, 33, 35, 34, 37, 38, 39, 43, 46, 40, 42, 41, 45, 47, 48, 52, 53, 54, 57, 56, 58, 60, 63],
    108: [17, 61, 6],
    109: [56, 32, 54],
    110: [23],
    111: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    112: [3, 40, 5, 7, 41, 11, 34, 13, 18, 54, 56, 25, 29, 35],
    113: [30, 20, 31, -1, 50],
    114: [20, -1],
    115: [56],
    116: [56, 32],
    117: [56, 32],
    118: [30, 31, -1, 50],
    119: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    120: [3, 40, 5, 7, 41, 11, 34, 13, 18, 54, 56, 25, 29, 35],
    121: [17],
    122: [23, 32, 54, 56],
    123: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    124: [54, 56, 11, 35],
    125: [36, 30, 20, 31, -1, 50],
    126: [-1],
    127: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    128: [3, 40, 5, 7, 41, 11, 34, 13, 18, 54, 56, 25, 29, 35],
    129: [18, 35, 54, 5, 7, 56, 11, 25, 29, 34],
    130: [56],
    131: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    132: [30, 20, 31, -1, 50],
    133: [35, 3, 40, 41, 7, 11, 13, 54, 56, 25, 29, 34],
    134: [54, 56, 11, 35],
}
rule_first = {
    0: [20, -1],
    1: [31, 50, 30, -1],
    2: [59],
    3: [30],
    4: [50],
    5: [31],
    6: [59],
    7: [-1, 11, 35, 54],
    8: [31],
    9: [11, 35, 54],
    10: [33],
    11: [49, 61, -1],
    12: [33],
    13: [49],
    14: [61],
    15: [1],
    16: [-1],
    17: [36, -1],
    18: [20],
    19: [1],
    20: [36],
    21: [18, 35, 54, 5, 7, 11, 25, -1, 29, 34],
    22: [50],
    23: [5],
    24: [29],
    25: [25],
    26: [18],
    27: [7],
    28: [34],
    29: [11, 35, 54],
    30: [6, 61, -1],
    31: [5],
    32: [6],
    33: [61],
    34: [38, -1],
    35: [61],
    36: [38],
    37: [-1, 11, 35, 54],
    38: [29],
    39: [18],
    40: [54, -1],
    41: [8],
    42: [54],
    43: [34],
    44: [7],
    45: [54, -1],
    46: [8],
    47: [54],
    48: [9],
    49: [-1],
    50: [11, 35, 54],
    51: [11, 35, 54],
    52: [9],
    53: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    54: [-1, 11, 35, 54],
    55: [25],
    56: [11, 35, 54],
    57: [54, 3, 40, 41, 7, 11, 25, -1, 34, 29, 13, 35],
    58: [30],
    59: [13],
    60: [11, 35, 54],
    61: [41],
    62: [40],
    63: [3],
    64: [29],
    65: [25],
    66: [7],
    67: [34],
    68: [1],
    69: [-1],
    70: [8],
    71: [-1],
    72: [13],
    73: [54, -1],
    74: [8],
    75: [1],
    76: [7],
    77: [34],
    78: [41],
    79: [40],
    80: [3],
    81: [54],
    82: [54],
    83: [33],
    84: [42],
    85: [58],
    86: [2],
    87: [10],
    88: [2, 42, 10, 58, 8, -1, 60, 62, 33],
    89: [60],
    90: [54, -1],
    91: [8],
    92: [-1, 11, 35, 54],
    93: [35],
    94: [35],
    95: [35],
    96: [35],
    97: [54],
    98: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    99: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    100: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    101: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    102: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    103: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    104: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    105: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    106: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    107: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    108: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    109: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    110: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    111: [53],
    112: [45],
    113: [46],
    114: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, -1, 28, 60, 63, 33],
    115: [54],
    116: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    117: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, 28, 60, 63, 33],
    118: [54, -1],
    119: [63],
    120: [60],
    121: [0, 53, 2, 54, 40, 42, 46, 8, 58, 45, -1, 28, 60, 63, 33],
    122: [8],
    123: [0],
    124: [40],
    125: [33],
    126: [54],
    127: [42],
    128: [58],
    129: [2],
}
nonterminal_rules = {
    65: [
        "$expression_placeholder = :expression_placeholder_start $_gen8 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    ],
    66: [
        "$import_namespace = :as :identifier -> $1",
    ],
    67: [
        "$string_piece = :string",
        "$string_piece = $expression_placeholder",
    ],
    68: [
        "$_gen2 = list($struct_declaration)",
    ],
    69: [
        "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    ],
    70: [
        "$_gen1 = list($file_body_element)",
    ],
    71: [
        "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    ],
    72: [
        "$while_loop = :while :lparen $e :rparen :lbrace $_gen14 :rbrace -> WhileLoop( expression=$2, body=$5 )",
    ],
    73: [
        "$_gen0 = list($import)",
    ],
    74: [
        "$_gen19 = list($meta_kv, :comma)",
    ],
    75: [
        "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    ],
    76: [
        "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    77: [
        "$_gen15 = $alias",
        "$_gen15 = :_empty",
    ],
    78: [
        "$_gen16 = $call_body",
        "$_gen16 = :_empty",
    ],
    79: [
        "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    ],
    80: [
        "$_gen6 = list($task_sections)",
    ],
    81: [
        "$_gen18 = list($meta_value, :comma)",
    ],
    82: [
        "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    ],
    83: [
        "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
        "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
        "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
        "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
        "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
        "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
        "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
        "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
        "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
        "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
        "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
        "$e = :not $e -> LogicalNot( expression=$1 )",
        "$e = :plus $e -> UnaryPlus( expression=$1 )",
        "$e = :dash $e -> UnaryNegation( expression=$1 )",
        "$e = :identifier <=> :lparen $_gen21 :rparen -> FunctionCall( name=$0, params=$2 )",
        "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
        "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
        "$e = :object :lbrace $_gen22 :rbrace -> ObjectLiteral( map=$2 )",
        "$e = :lsquare $_gen21 :rsquare -> ArrayLiteral( values=$1 )",
        "$e = :lbrace $_gen23 :rbrace -> MapLiteral( map=$1 )",
        "$e = :lparen $_gen21 :rparen -> TupleLiteral( values=$1 )",
        "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
        "$e = $string_literal",
        "$e = :identifier",
        "$e = :boolean",
        "$e = :integer",
        "$e = :float",
    ],
    84: [
        "$_gen8 = list($expression_placeholder_kv)",
    ],
    85: [
        "$_gen14 = list($wf_body_element)",
    ],
    86: [
        "$_gen3 = list($string_piece)",
    ],
    87: [
        "$_gen10 = list($kv)",
    ],
    88: [
        "$meta_map = :lbrace $_gen11 :rbrace -> $1",
    ],
    89: [
        "$_gen12 = $setter",
        "$_gen12 = :_empty",
    ],
    90: [
        "$call = :call :fqn $_gen15 $_gen16 -> Call( task=$1, alias=$2, body=$3 )",
    ],
    91: [
        "$task_sections = $command",
        "$task_sections = $inputs",
        "$task_sections = $outputs",
        "$task_sections = $runtime",
        "$task_sections = $parameter_meta",
        "$task_sections = $meta",
        "$task_sections = $declaration",
    ],
    92: [
        "$type_e = :type <=> :lsquare $_gen20 :rsquare -> Type( name=$0, subtype=$2 )",
        "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
        "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
        "$type_e = :type",
        "$type_e = :identifier",
    ],
    93: [
        "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    94: [
        "$workflow = :workflow :identifier :lbrace $_gen14 :rbrace -> Workflow( name=$1, body=$3 )",
    ],
    95: [
        "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    ],
    96: [
        "$_gen13 = list($output_kv)",
    ],
    97: [
        "$alias = :as :identifier -> $1",
    ],
    98: [
        "$if_stmt = :if :lparen $e :rparen :lbrace $_gen14 :rbrace -> If( expression=$2, body=$5 )",
    ],
    99: [
        "$_gen21 = list($e, :comma)",
    ],
    100: [
        "$static_string = :quote :string :quote -> $1",
    ],
    101: [
        "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen14 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    ],
    102: [
        "$_gen17 = list($input_kv, :comma)",
    ],
    103: [
        "$_gen22 = list($object_kv, :comma)",
    ],
    104: [
        "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    ],
    105: [
        "$_gen23 = list($map_kv, :comma)",
    ],
    106: [
        "$task = :task :identifier :lbrace $_gen6 :rbrace -> Task( name=$1, sections=$3 )",
    ],
    107: [
        "$string_literal = :quote $_gen3 :quote -> StringLiteral( pieces=$1 )",
    ],
    108: [
        "$command_part = :cmd_part",
        "$command_part = $expression_placeholder",
    ],
    109: [
        "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    ],
    110: [
        "$_gen20 = list($type_e, :comma)",
    ],
    111: [
        "$command = :raw_command :raw_cmd_start $_gen7 :raw_cmd_end -> RawCommand( parts=$2 )",
    ],
    112: [
        "$outputs = :output :lbrace $_gen13 :rbrace -> Outputs( outputs=$2 )",
    ],
    113: [
        "$_gen5 = list($import_alias)",
    ],
    114: [
        "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    ],
    115: [
        "$_gen11 = list($meta_kv)",
    ],
    116: [
        "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    ],
    117: [
        "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    ],
    118: [
        "$file_body_element = $workflow",
        "$file_body_element = $task",
        "$file_body_element = $struct",
    ],
    119: [
        "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    ],
    120: [
        "$setter = :equal $e -> $1",
    ],
    121: [
        "$_gen7 = list($command_part)",
    ],
    122: [
        "$meta_value = $static_string",
        "$meta_value = :boolean",
        "$meta_value = :integer",
        "$meta_value = :float",
        "$meta_value = :null",
        "$meta_value = :lsquare $_gen18 :rsquare -> MetaArray( values=$1 )",
        "$meta_value = :lbrace $_gen19 :rbrace -> MetaObject( map=$1 )",
    ],
    123: [
        "$call_body = :lbrace :input :colon $_gen17 :rbrace -> CallBody( inputs=$3 )",
    ],
    124: [
        "$input_declaration = $type_e :identifier $_gen12 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    ],
    125: [
        "$_gen4 = $import_namespace",
        "$_gen4 = :_empty",
    ],
    126: [
        "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    ],
    127: [
        "$meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    128: [
        "$inputs = :input :lbrace $_gen9 :rbrace -> Inputs( inputs=$2 )",
    ],
    129: [
        "$rt_map = :lbrace $_gen10 :rbrace -> $1",
    ],
    130: [
        "$_gen9 = list($input_declaration)",
    ],
    131: [
        "$wf_body_element = $call",
        "$wf_body_element = $declaration",
        "$wf_body_element = $while_loop",
        "$wf_body_element = $if_stmt",
        "$wf_body_element = $scatter",
        "$wf_body_element = $inputs",
        "$wf_body_element = $outputs",
        "$wf_body_element = $wf_parameter_meta",
        "$wf_body_element = $wf_meta",
    ],
    132: [
        "$import = :import $static_string $_gen4 $_gen5 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    ],
    133: [
        "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    134: [
        "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    ],
}
rules = {
    0: "$_gen0 = list($import)",
    1: "$_gen1 = list($file_body_element)",
    2: "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    3: "$file_body_element = $workflow",
    4: "$file_body_element = $task",
    5: "$file_body_element = $struct",
    6: "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    7: "$_gen2 = list($struct_declaration)",
    8: "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    9: "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    10: "$static_string = :quote :string :quote -> $1",
    11: "$_gen3 = list($string_piece)",
    12: "$string_literal = :quote $_gen3 :quote -> StringLiteral( pieces=$1 )",
    13: "$string_piece = :string",
    14: "$string_piece = $expression_placeholder",
    15: "$_gen4 = $import_namespace",
    16: "$_gen4 = :_empty",
    17: "$_gen5 = list($import_alias)",
    18: "$import = :import $static_string $_gen4 $_gen5 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    19: "$import_namespace = :as :identifier -> $1",
    20: "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    21: "$_gen6 = list($task_sections)",
    22: "$task = :task :identifier :lbrace $_gen6 :rbrace -> Task( name=$1, sections=$3 )",
    23: "$task_sections = $command",
    24: "$task_sections = $inputs",
    25: "$task_sections = $outputs",
    26: "$task_sections = $runtime",
    27: "$task_sections = $parameter_meta",
    28: "$task_sections = $meta",
    29: "$task_sections = $declaration",
    30: "$_gen7 = list($command_part)",
    31: "$command = :raw_command :raw_cmd_start $_gen7 :raw_cmd_end -> RawCommand( parts=$2 )",
    32: "$command_part = :cmd_part",
    33: "$command_part = $expression_placeholder",
    34: "$_gen8 = list($expression_placeholder_kv)",
    35: "$expression_placeholder = :expression_placeholder_start $_gen8 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    36: "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    37: "$_gen9 = list($input_declaration)",
    38: "$inputs = :input :lbrace $_gen9 :rbrace -> Inputs( inputs=$2 )",
    39: "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    40: "$_gen10 = list($kv)",
    41: "$rt_map = :lbrace $_gen10 :rbrace -> $1",
    42: "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    43: "$meta = :meta $meta_map -> Meta( map=$1 )",
    44: "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    45: "$_gen11 = list($meta_kv)",
    46: "$meta_map = :lbrace $_gen11 :rbrace -> $1",
    47: "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    48: "$_gen12 = $setter",
    49: "$_gen12 = :_empty",
    50: "$input_declaration = $type_e :identifier $_gen12 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    51: "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    52: "$setter = :equal $e -> $1",
    53: "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    54: "$_gen13 = list($output_kv)",
    55: "$outputs = :output :lbrace $_gen13 :rbrace -> Outputs( outputs=$2 )",
    56: "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    57: "$_gen14 = list($wf_body_element)",
    58: "$workflow = :workflow :identifier :lbrace $_gen14 :rbrace -> Workflow( name=$1, body=$3 )",
    59: "$wf_body_element = $call",
    60: "$wf_body_element = $declaration",
    61: "$wf_body_element = $while_loop",
    62: "$wf_body_element = $if_stmt",
    63: "$wf_body_element = $scatter",
    64: "$wf_body_element = $inputs",
    65: "$wf_body_element = $outputs",
    66: "$wf_body_element = $wf_parameter_meta",
    67: "$wf_body_element = $wf_meta",
    68: "$_gen15 = $alias",
    69: "$_gen15 = :_empty",
    70: "$_gen16 = $call_body",
    71: "$_gen16 = :_empty",
    72: "$call = :call :fqn $_gen15 $_gen16 -> Call( task=$1, alias=$2, body=$3 )",
    73: "$_gen17 = list($input_kv, :comma)",
    74: "$call_body = :lbrace :input :colon $_gen17 :rbrace -> CallBody( inputs=$3 )",
    75: "$alias = :as :identifier -> $1",
    76: "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    77: "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    78: "$while_loop = :while :lparen $e :rparen :lbrace $_gen14 :rbrace -> WhileLoop( expression=$2, body=$5 )",
    79: "$if_stmt = :if :lparen $e :rparen :lbrace $_gen14 :rbrace -> If( expression=$2, body=$5 )",
    80: "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen14 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    81: "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    82: "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    83: "$meta_value = $static_string",
    84: "$meta_value = :boolean",
    85: "$meta_value = :integer",
    86: "$meta_value = :float",
    87: "$meta_value = :null",
    88: "$_gen18 = list($meta_value, :comma)",
    89: "$meta_value = :lsquare $_gen18 :rsquare -> MetaArray( values=$1 )",
    90: "$_gen19 = list($meta_kv, :comma)",
    91: "$meta_value = :lbrace $_gen19 :rbrace -> MetaObject( map=$1 )",
    92: "$_gen20 = list($type_e, :comma)",
    93: "$type_e = :type <=> :lsquare $_gen20 :rsquare -> Type( name=$0, subtype=$2 )",
    94: "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
    95: "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
    96: "$type_e = :type",
    97: "$type_e = :identifier",
    98: "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
    99: "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
    100: "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
    101: "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
    102: "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
    103: "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
    104: "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
    105: "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
    106: "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
    107: "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
    108: "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
    109: "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
    110: "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
    111: "$e = :not $e -> LogicalNot( expression=$1 )",
    112: "$e = :plus $e -> UnaryPlus( expression=$1 )",
    113: "$e = :dash $e -> UnaryNegation( expression=$1 )",
    114: "$_gen21 = list($e, :comma)",
    115: "$e = :identifier <=> :lparen $_gen21 :rparen -> FunctionCall( name=$0, params=$2 )",
    116: "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
    117: "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
    118: "$_gen22 = list($object_kv, :comma)",
    119: "$e = :object :lbrace $_gen22 :rbrace -> ObjectLiteral( map=$2 )",
    120: "$e = :lsquare $_gen21 :rsquare -> ArrayLiteral( values=$1 )",
    121: "$_gen23 = list($map_kv, :comma)",
    122: "$e = :lbrace $_gen23 :rbrace -> MapLiteral( map=$1 )",
    123: "$e = :lparen $_gen21 :rparen -> TupleLiteral( values=$1 )",
    124: "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
    125: "$e = $string_literal",
    126: "$e = :identifier",
    127: "$e = :boolean",
    128: "$e = :integer",
    129: "$e = :float",
}
def is_terminal(id): return isinstance(id, int) and 0 <= id <= 64
def parse(tokens, errors=None, start=None):
    if errors is None:
        errors = DefaultSyntaxErrorHandler()
    if isinstance(tokens, str):
        tokens = lex(tokens, 'string', errors)
    ctx = ParserContext(tokens, errors)
    tree = parse_document(ctx)
    if tokens.current() != None:
        raise ctx.errors.excess_tokens()
    return tree
def expect(ctx, terminal_id):
    current = ctx.tokens.current()
    if not current:
        raise ctx.errors.no_more_tokens(ctx.nonterminal, terminals[terminal_id], ctx.tokens.last())
    if current.id != terminal_id:
        raise ctx.errors.unexpected_symbol(ctx.nonterminal, current, [terminals[terminal_id]], ctx.rule)
    next = ctx.tokens.advance()
    if next and not is_terminal(next.id):
        raise ctx.errors.invalid_terminal(ctx.nonterminal, next)
    return current
# START definitions for expression parser: e
infix_binding_power_e = {
    22: 4000, # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
    43: 5000, # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
    14: 6000, # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
    15: 6000, # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
    37: 7000, # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
    16: 7000, # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
    57: 7000, # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
    52: 7000, # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
    45: 8000, # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
    46: 8000, # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
    47: 9000, # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
    4: 9000, # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
    24: 9000, # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
    0: 11000, # $e = :identifier <=> :lparen list($e, :comma) :rparen -> FunctionCall( name=$0, params=$2 )
    60: 12000, # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
    19: 13000, # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
}
prefix_binding_power_e = {
    53: 10000, # $e = :not $e -> LogicalNot( expression=$1 )
    45: 10000, # $e = :plus $e -> UnaryPlus( expression=$1 )
    46: 10000, # $e = :dash $e -> UnaryNegation( expression=$1 )
}
def get_infix_binding_power_e(terminal_id):
    try:
        return infix_binding_power_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_e(terminal_id):
    try:
        return prefix_binding_power_e[terminal_id]
    except:
        return 0
def parse_e(ctx):
    return parse_e_internal(ctx, rbp=0)
def parse_e_internal(ctx, rbp=0):
    left = nud_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_e(ctx.tokens.current().id):
        left = led_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_e(ctx):
    tree = ParseTree(NonTerminal(83, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if not current:
        return tree
    elif current.id in rule_first[111]:
        # rule first == not
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :not $e -> LogicalNot( expression=$1 )
        ctx.rule = rules[111]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalNot', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 53))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(53)))
        tree.isPrefix = True
    elif current.id in rule_first[112]:
        # rule first == plus
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :plus $e -> UnaryPlus( expression=$1 )
        ctx.rule = rules[112]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryPlus', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 45))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(45)))
        tree.isPrefix = True
    elif current.id in rule_first[113]:
        # rule first == dash
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :dash $e -> UnaryNegation( expression=$1 )
        ctx.rule = rules[113]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryNegation', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 46))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(46)))
        tree.isPrefix = True
    elif current.id in rule_first[115]:
        # rule first == identifier
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :identifier <=> :lparen $_gen21 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[115]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 54))
    elif current.id in rule_first[119]:
        # rule first == object
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :object :lbrace $_gen22 :rbrace -> ObjectLiteral( map=$2 )
        ctx.rule = rules[119]
        ast_parameters = OrderedDict([
            ('map', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectLiteral', ast_parameters)
        tree.nudMorphemeCount = 4
        tree.add(expect(ctx, 63))
        tree.add(expect(ctx, 8))
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 56))
    elif current.id in rule_first[120]:
        # rule first == lsquare
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :lsquare $_gen21 :rsquare -> ArrayLiteral( values=$1 )
        ctx.rule = rules[120]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 60))
        tree.add(parse__gen21(ctx))
        tree.add(expect(ctx, 23))
    elif current.id in rule_first[122]:
        # rule first == lbrace
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :lbrace $_gen23 :rbrace -> MapLiteral( map=$1 )
        ctx.rule = rules[122]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 8))
        tree.add(parse__gen23(ctx))
        tree.add(expect(ctx, 56))
    elif current.id in rule_first[123]:
        # rule first == lparen
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :lparen $_gen21 :rparen -> TupleLiteral( values=$1 )
        ctx.rule = rules[123]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('TupleLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 0))
        tree.add(parse__gen21(ctx))
        tree.add(expect(ctx, 48))
    elif current.id in rule_first[124]:
        # rule first == if
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )
        ctx.rule = rules[124]
        ast_parameters = OrderedDict([
            ('cond', 1),
            ('iftrue', 3),
            ('iffalse', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('TernaryIf', ast_parameters)
        tree.nudMorphemeCount = 6
        tree.add(expect(ctx, 40))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 27))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 26))
        tree.add(parse_e(ctx))
    elif current.id in rule_first[125]:
        # rule first == quote
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = $string_literal
        ctx.rule = rules[125]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_string_literal(ctx))
    elif current.id in rule_first[126]:
        # rule first == identifier
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :identifier
        ctx.rule = rules[126]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 54))
    elif current.id in rule_first[127]:
        # rule first == boolean
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :boolean
        ctx.rule = rules[127]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 42))
    elif current.id in rule_first[128]:
        # rule first == integer
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :integer
        ctx.rule = rules[128]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 58))
    elif current.id in rule_first[129]:
        # rule first == float
        # e first == lparen, not, float, identifier, if, boolean, dash, lbrace, integer, plus, e, lsquare, object, quote
        # $e = :float
        ctx.rule = rules[129]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 2))
    return tree
def led_e(left, ctx):
    tree = ParseTree(NonTerminal(83, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if current.id == 22: # :double_pipe
        # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
        ctx.rule = rules[98]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalOr', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 22)) # :double_pipe
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(22) - modifier))
    if current.id == 43: # :double_ampersand
        # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
        ctx.rule = rules[99]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalAnd', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 43)) # :double_ampersand
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(43) - modifier))
    if current.id == 14: # :double_equal
        # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
        ctx.rule = rules[100]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Equals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 14)) # :double_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(14) - modifier))
    if current.id == 15: # :not_equal
        # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
        ctx.rule = rules[101]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('NotEquals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 15)) # :not_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(15) - modifier))
    if current.id == 37: # :lt
        # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[102]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 37)) # :lt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(37) - modifier))
    if current.id == 16: # :lteq
        # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[103]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 16)) # :lteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(16) - modifier))
    if current.id == 57: # :gt
        # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[104]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 57)) # :gt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(57) - modifier))
    if current.id == 52: # :gteq
        # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[105]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 52)) # :gteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(52) - modifier))
    if current.id == 45: # :plus
        # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
        ctx.rule = rules[106]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Add', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 45)) # :plus
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(45) - modifier))
    if current.id == 46: # :dash
        # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
        ctx.rule = rules[107]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Subtract', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 46)) # :dash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(46) - modifier))
    if current.id == 47: # :asterisk
        # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
        ctx.rule = rules[108]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Multiply', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 47)) # :asterisk
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(47) - modifier))
    if current.id == 4: # :slash
        # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
        ctx.rule = rules[109]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Divide', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 4)) # :slash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(4) - modifier))
    if current.id == 24: # :percent
        # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
        ctx.rule = rules[110]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Remainder', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 24)) # :percent
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(24) - modifier))
    if current.id == 0: # :lparen
        # $e = :identifier <=> :lparen $_gen21 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[115]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('params', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('FunctionCall', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 0)) # :lparen
        tree.add(parse__gen21(ctx))
        tree.add(expect(ctx, 48)) # :rparen
    if current.id == 60: # :lsquare
        # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
        ctx.rule = rules[116]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayOrMapLookup', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 60)) # :lsquare
        modifier = 0
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(60) - modifier))
        tree.add(expect(ctx, 23)) # :rsquare
    if current.id == 19: # :dot
        # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
        ctx.rule = rules[117]
        ast_parameters = OrderedDict([
            ('value', 0),
            ('member', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MemberAccess', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 19)) # :dot
        tree.add(expect(ctx, 54)) # :identifier
    return tree
# END definitions for expression parser: e
# START definitions for expression parser: meta_value
infix_binding_power_meta_value = {
}
prefix_binding_power_meta_value = {
}
def get_infix_binding_power_meta_value(terminal_id):
    try:
        return infix_binding_power_meta_value[terminal_id]
    except:
        return 0
def get_prefix_binding_power_meta_value(terminal_id):
    try:
        return prefix_binding_power_meta_value[terminal_id]
    except:
        return 0
def parse_meta_value(ctx):
    return parse_meta_value_internal(ctx, rbp=0)
def parse_meta_value_internal(ctx, rbp=0):
    left = nud_meta_value(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_meta_value(ctx.tokens.current().id):
        left = led_meta_value(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_meta_value(ctx):
    tree = ParseTree(NonTerminal(122, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    if not current:
        return tree
    if current.id in rule_first[83]:
        # rule first == quote
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = $static_string
        ctx.rule = rules[83]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_static_string(ctx))
    elif current.id in rule_first[84]:
        # rule first == boolean
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :boolean
        ctx.rule = rules[84]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 42))
    elif current.id in rule_first[85]:
        # rule first == integer
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :integer
        ctx.rule = rules[85]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 58))
    elif current.id in rule_first[86]:
        # rule first == float
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :float
        ctx.rule = rules[86]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 2))
    elif current.id in rule_first[87]:
        # rule first == null
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :null
        ctx.rule = rules[87]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 10))
    elif current.id in rule_first[89]:
        # rule first == lsquare
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :lsquare $_gen18 :rsquare -> MetaArray( values=$1 )
        ctx.rule = rules[89]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaArray', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 60))
        tree.add(parse__gen18(ctx))
        tree.add(expect(ctx, 23))
    elif current.id in rule_first[91]:
        # rule first == lbrace
        # e first == boolean, float, meta_value, lsquare, quote, null, integer, lbrace
        # $meta_value = :lbrace $_gen19 :rbrace -> MetaObject( map=$1 )
        ctx.rule = rules[91]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaObject', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 8))
        tree.add(parse__gen19(ctx))
        tree.add(expect(ctx, 56))
    return tree
def led_meta_value(left, ctx):
    tree = ParseTree(NonTerminal(122, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    return tree
# END definitions for expression parser: meta_value
# START definitions for expression parser: type_e
infix_binding_power_type_e = {
    60: 1000, # $type_e = :type <=> :lsquare list($type_e, :comma) :rsquare -> Type( name=$0, subtype=$2 )
    64: 2000, # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
    45: 3000, # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
}
prefix_binding_power_type_e = {
}
def get_infix_binding_power_type_e(terminal_id):
    try:
        return infix_binding_power_type_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_type_e(terminal_id):
    try:
        return prefix_binding_power_type_e[terminal_id]
    except:
        return 0
def parse_type_e(ctx):
    return parse_type_e_internal(ctx, rbp=0)
def parse_type_e_internal(ctx, rbp=0):
    left = nud_type_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_type_e(ctx.tokens.current().id):
        left = led_type_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_type_e(ctx):
    tree = ParseTree(NonTerminal(92, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if not current:
        return tree
    if current.id in rule_first[93]:
        # rule first == type
        # e first == type_e, type, identifier
        # $type_e = :type <=> :lsquare $_gen20 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[93]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 35))
    elif current.id in rule_first[94]:
        # rule first == type
        # e first == type_e, type, identifier
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[94]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 35))
    elif current.id in rule_first[95]:
        # rule first == type
        # e first == type_e, type, identifier
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[95]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 35))
    elif current.id in rule_first[96]:
        # rule first == type
        # e first == type_e, type, identifier
        # $type_e = :type
        ctx.rule = rules[96]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 35))
    elif current.id in rule_first[97]:
        # rule first == identifier
        # e first == type_e, type, identifier
        # $type_e = :identifier
        ctx.rule = rules[97]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 54))
    return tree
def led_type_e(left, ctx):
    tree = ParseTree(NonTerminal(92, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if current.id == 60: # :lsquare
        # $type_e = :type <=> :lsquare $_gen20 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[93]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('subtype', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Type', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 60)) # :lsquare
        tree.add(parse__gen20(ctx))
        tree.add(expect(ctx, 23)) # :rsquare
    if current.id == 64: # :qmark
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[94]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('OptionalType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 64)) # :qmark
    if current.id == 45: # :plus
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[95]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('NonEmptyType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 45)) # :plus
    return tree
# END definitions for expression parser: type_e
def parse__gen0(ctx):
    tree = ParseTree(NonTerminal(73, '_gen0'))
    tree.list = True
    ctx.nonterminal = "_gen0"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[73] and \
       ctx.tokens.current().id in nonterminal_follow[73]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(73)):
        tree.add(parse_import(ctx))
        ctx.nonterminal = "_gen0" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen1(ctx):
    tree = ParseTree(NonTerminal(70, '_gen1'))
    tree.list = True
    ctx.nonterminal = "_gen1"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[70] and \
       ctx.tokens.current().id in nonterminal_follow[70]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(70)):
        tree.add(parse_file_body_element(ctx))
        ctx.nonterminal = "_gen1" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen10(ctx):
    tree = ParseTree(NonTerminal(87, '_gen10'))
    tree.list = True
    ctx.nonterminal = "_gen10"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[87] and \
       ctx.tokens.current().id in nonterminal_follow[87]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(87)):
        tree.add(parse_kv(ctx))
        ctx.nonterminal = "_gen10" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen11(ctx):
    tree = ParseTree(NonTerminal(115, '_gen11'))
    tree.list = True
    ctx.nonterminal = "_gen11"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[115] and \
       ctx.tokens.current().id in nonterminal_follow[115]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(115)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen11" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen13(ctx):
    tree = ParseTree(NonTerminal(96, '_gen13'))
    tree.list = True
    ctx.nonterminal = "_gen13"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[96] and \
       ctx.tokens.current().id in nonterminal_follow[96]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(96)):
        tree.add(parse_output_kv(ctx))
        ctx.nonterminal = "_gen13" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen14(ctx):
    tree = ParseTree(NonTerminal(85, '_gen14'))
    tree.list = True
    ctx.nonterminal = "_gen14"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[85] and \
       ctx.tokens.current().id in nonterminal_follow[85]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(85)):
        tree.add(parse_wf_body_element(ctx))
        ctx.nonterminal = "_gen14" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen17(ctx):
    tree = ParseTree(NonTerminal(102, '_gen17'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen17"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[102] and \
       ctx.tokens.current().id in nonterminal_follow[102]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(102)):
        tree.add(parse_input_kv(ctx))
        ctx.nonterminal = "_gen17" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen18(ctx):
    tree = ParseTree(NonTerminal(81, '_gen18'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen18"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[81] and \
       ctx.tokens.current().id in nonterminal_follow[81]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(81)):
        tree.add(parse_meta_value(ctx))
        ctx.nonterminal = "_gen18" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen19(ctx):
    tree = ParseTree(NonTerminal(74, '_gen19'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen19"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[74] and \
       ctx.tokens.current().id in nonterminal_follow[74]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(74)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen19" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen2(ctx):
    tree = ParseTree(NonTerminal(68, '_gen2'))
    tree.list = True
    ctx.nonterminal = "_gen2"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[68] and \
       ctx.tokens.current().id in nonterminal_follow[68]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(68)):
        tree.add(parse_struct_declaration(ctx))
        ctx.nonterminal = "_gen2" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen20(ctx):
    tree = ParseTree(NonTerminal(110, '_gen20'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen20"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[110] and \
       ctx.tokens.current().id in nonterminal_follow[110]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(110)):
        tree.add(parse_type_e(ctx))
        ctx.nonterminal = "_gen20" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen21(ctx):
    tree = ParseTree(NonTerminal(99, '_gen21'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen21"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[99] and \
       ctx.tokens.current().id in nonterminal_follow[99]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(99)):
        tree.add(parse_e(ctx))
        ctx.nonterminal = "_gen21" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen22(ctx):
    tree = ParseTree(NonTerminal(103, '_gen22'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen22"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[103] and \
       ctx.tokens.current().id in nonterminal_follow[103]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(103)):
        tree.add(parse_object_kv(ctx))
        ctx.nonterminal = "_gen22" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen23(ctx):
    tree = ParseTree(NonTerminal(105, '_gen23'))
    tree.list = True
    tree.list_separator_id = 32
    ctx.nonterminal = "_gen23"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[105] and \
       ctx.tokens.current().id in nonterminal_follow[105]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(105)):
        tree.add(parse_map_kv(ctx))
        ctx.nonterminal = "_gen23" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 32:
            tree.add(expect(ctx, 32));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen3(ctx):
    tree = ParseTree(NonTerminal(86, '_gen3'))
    tree.list = True
    ctx.nonterminal = "_gen3"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[86] and \
       ctx.tokens.current().id in nonterminal_follow[86]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(86)):
        tree.add(parse_string_piece(ctx))
        ctx.nonterminal = "_gen3" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen5(ctx):
    tree = ParseTree(NonTerminal(113, '_gen5'))
    tree.list = True
    ctx.nonterminal = "_gen5"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[113] and \
       ctx.tokens.current().id in nonterminal_follow[113]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(113)):
        tree.add(parse_import_alias(ctx))
        ctx.nonterminal = "_gen5" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen6(ctx):
    tree = ParseTree(NonTerminal(80, '_gen6'))
    tree.list = True
    ctx.nonterminal = "_gen6"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[80] and \
       ctx.tokens.current().id in nonterminal_follow[80]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(80)):
        tree.add(parse_task_sections(ctx))
        ctx.nonterminal = "_gen6" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen7(ctx):
    tree = ParseTree(NonTerminal(121, '_gen7'))
    tree.list = True
    ctx.nonterminal = "_gen7"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[121] and \
       ctx.tokens.current().id in nonterminal_follow[121]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(121)):
        tree.add(parse_command_part(ctx))
        ctx.nonterminal = "_gen7" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen8(ctx):
    tree = ParseTree(NonTerminal(84, '_gen8'))
    tree.list = True
    ctx.nonterminal = "_gen8"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[84] and \
       ctx.tokens.current().id in nonterminal_follow[84]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(84)):
        tree.add(parse_expression_placeholder_kv(ctx))
        ctx.nonterminal = "_gen8" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen9(ctx):
    tree = ParseTree(NonTerminal(130, '_gen9'))
    tree.list = True
    ctx.nonterminal = "_gen9"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[130] and \
       ctx.tokens.current().id in nonterminal_follow[130]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(130)):
        tree.add(parse_input_declaration(ctx))
        ctx.nonterminal = "_gen9" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen12(ctx):
    current = ctx.tokens.current()
    rule = table[24][current.id] if current else -1
    tree = ParseTree(NonTerminal(89, '_gen12'))
    ctx.nonterminal = "_gen12"
    if current != None and current.id in nonterminal_follow[89] and current.id not in nonterminal_first[89]:
        return tree
    if current == None:
        return tree
    if rule == 48: # $_gen12 = $setter
        ctx.rule = rules[48]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen15(ctx):
    current = ctx.tokens.current()
    rule = table[12][current.id] if current else -1
    tree = ParseTree(NonTerminal(77, '_gen15'))
    ctx.nonterminal = "_gen15"
    if current != None and current.id in nonterminal_follow[77] and current.id not in nonterminal_first[77]:
        return tree
    if current == None:
        return tree
    if rule == 68: # $_gen15 = $alias
        ctx.rule = rules[68]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_alias(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen16(ctx):
    current = ctx.tokens.current()
    rule = table[13][current.id] if current else -1
    tree = ParseTree(NonTerminal(78, '_gen16'))
    ctx.nonterminal = "_gen16"
    if current != None and current.id in nonterminal_follow[78] and current.id not in nonterminal_first[78]:
        return tree
    if current == None:
        return tree
    if rule == 70: # $_gen16 = $call_body
        ctx.rule = rules[70]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call_body(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen4(ctx):
    current = ctx.tokens.current()
    rule = table[60][current.id] if current else -1
    tree = ParseTree(NonTerminal(125, '_gen4'))
    ctx.nonterminal = "_gen4"
    if current != None and current.id in nonterminal_follow[125] and current.id not in nonterminal_first[125]:
        return tree
    if current == None:
        return tree
    if rule == 15: # $_gen4 = $import_namespace
        ctx.rule = rules[15]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_import_namespace(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse_alias(ctx):
    current = ctx.tokens.current()
    rule = table[32][current.id] if current else -1
    tree = ParseTree(NonTerminal(97, 'alias'))
    ctx.nonterminal = "alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 75: # $alias = :as :identifier -> $1
        ctx.rule = rules[75]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 1) # :as
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[97] if x >=0],
      rules[75]
    )
def parse_call(ctx):
    current = ctx.tokens.current()
    rule = table[25][current.id] if current else -1
    tree = ParseTree(NonTerminal(90, 'call'))
    ctx.nonterminal = "call"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 72: # $call = :call :fqn $_gen15 $_gen16 -> Call( task=$1, alias=$2, body=$3 )
        ctx.rule = rules[72]
        ast_parameters = OrderedDict([
            ('task', 1),
            ('alias', 2),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Call', ast_parameters)
        t = expect(ctx, 13) # :call
        tree.add(t)
        t = expect(ctx, 44) # :fqn
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        subtree = parse__gen16(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[90] if x >=0],
      rules[72]
    )
def parse_call_body(ctx):
    current = ctx.tokens.current()
    rule = table[58][current.id] if current else -1
    tree = ParseTree(NonTerminal(123, 'call_body'))
    ctx.nonterminal = "call_body"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 74: # $call_body = :lbrace :input :colon $_gen17 :rbrace -> CallBody( inputs=$3 )
        ctx.rule = rules[74]
        ast_parameters = OrderedDict([
            ('inputs', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('CallBody', ast_parameters)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        t = expect(ctx, 29) # :input
        tree.add(t)
        t = expect(ctx, 39) # :colon
        tree.add(t)
        subtree = parse__gen17(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[123] if x >=0],
      rules[74]
    )
def parse_command(ctx):
    current = ctx.tokens.current()
    rule = table[46][current.id] if current else -1
    tree = ParseTree(NonTerminal(111, 'command'))
    ctx.nonterminal = "command"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 31: # $command = :raw_command :raw_cmd_start $_gen7 :raw_cmd_end -> RawCommand( parts=$2 )
        ctx.rule = rules[31]
        ast_parameters = OrderedDict([
            ('parts', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RawCommand', ast_parameters)
        t = expect(ctx, 5) # :raw_command
        tree.add(t)
        t = expect(ctx, 12) # :raw_cmd_start
        tree.add(t)
        subtree = parse__gen7(ctx)
        tree.add(subtree)
        t = expect(ctx, 17) # :raw_cmd_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[111] if x >=0],
      rules[31]
    )
def parse_command_part(ctx):
    current = ctx.tokens.current()
    rule = table[43][current.id] if current else -1
    tree = ParseTree(NonTerminal(108, 'command_part'))
    ctx.nonterminal = "command_part"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 32: # $command_part = :cmd_part
        ctx.rule = rules[32]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 6) # :cmd_part
        tree.add(t)
        return tree
    elif rule == 33: # $command_part = $expression_placeholder
        ctx.rule = rules[33]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[108] if x >=0],
      rules[33]
    )
def parse_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[14][current.id] if current else -1
    tree = ParseTree(NonTerminal(79, 'declaration'))
    ctx.nonterminal = "declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 51: # $declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[51]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Declaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[79] if x >=0],
      rules[51]
    )
def parse_document(ctx):
    current = ctx.tokens.current()
    rule = table[61][current.id] if current else -1
    tree = ParseTree(NonTerminal(126, 'document'))
    ctx.nonterminal = "document"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 2: # $document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )
        ctx.rule = rules[2]
        ast_parameters = OrderedDict([
            ('version', 0),
            ('imports', 1),
            ('body', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Draft3File', ast_parameters)
        subtree = parse_version(ctx)
        tree.add(subtree)
        subtree = parse__gen0(ctx)
        tree.add(subtree)
        subtree = parse__gen1(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[126] if x >=0],
      rules[2]
    )
def parse_expression_placeholder(ctx):
    current = ctx.tokens.current()
    rule = table[0][current.id] if current else -1
    tree = ParseTree(NonTerminal(65, 'expression_placeholder'))
    ctx.nonterminal = "expression_placeholder"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 35: # $expression_placeholder = :expression_placeholder_start $_gen8 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )
        ctx.rule = rules[35]
        ast_parameters = OrderedDict([
            ('attributes', 1),
            ('expr', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholder', ast_parameters)
        t = expect(ctx, 61) # :expression_placeholder_start
        tree.add(t)
        subtree = parse__gen8(ctx)
        tree.add(subtree)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 21) # :expression_placeholder_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[65] if x >=0],
      rules[35]
    )
def parse_expression_placeholder_kv(ctx):
    current = ctx.tokens.current()
    rule = table[17][current.id] if current else -1
    tree = ParseTree(NonTerminal(82, 'expression_placeholder_kv'))
    ctx.nonterminal = "expression_placeholder_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 36: # $expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )
        ctx.rule = rules[36]
        ast_parameters = OrderedDict([
            ('key', 1),
            ('value', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholderAttr', ast_parameters)
        t = expect(ctx, 38) # :cmd_attr_hint
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[82] if x >=0],
      rules[36]
    )
def parse_file_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[53][current.id] if current else -1
    tree = ParseTree(NonTerminal(118, 'file_body_element'))
    ctx.nonterminal = "file_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 3: # $file_body_element = $workflow
        ctx.rule = rules[3]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_workflow(ctx)
        tree.add(subtree)
        return tree
    elif rule == 4: # $file_body_element = $task
        ctx.rule = rules[4]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_task(ctx)
        tree.add(subtree)
        return tree
    elif rule == 5: # $file_body_element = $struct
        ctx.rule = rules[5]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_struct(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[118] if x >=0],
      rules[5]
    )
def parse_if_stmt(ctx):
    current = ctx.tokens.current()
    rule = table[33][current.id] if current else -1
    tree = ParseTree(NonTerminal(98, 'if_stmt'))
    ctx.nonterminal = "if_stmt"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 79: # $if_stmt = :if :lparen $e :rparen :lbrace $_gen14 :rbrace -> If( expression=$2, body=$5 )
        ctx.rule = rules[79]
        ast_parameters = OrderedDict([
            ('expression', 2),
            ('body', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('If', ast_parameters)
        t = expect(ctx, 40) # :if
        tree.add(t)
        t = expect(ctx, 0) # :lparen
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 48) # :rparen
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[98] if x >=0],
      rules[79]
    )
def parse_import(ctx):
    current = ctx.tokens.current()
    rule = table[67][current.id] if current else -1
    tree = ParseTree(NonTerminal(132, 'import'))
    ctx.nonterminal = "import"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 18: # $import = :import $static_string $_gen4 $_gen5 -> Import( uri=$1, namespace=$2, aliases=$3 )
        ctx.rule = rules[18]
        ast_parameters = OrderedDict([
            ('uri', 1),
            ('namespace', 2),
            ('aliases', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Import', ast_parameters)
        t = expect(ctx, 20) # :import
        tree.add(t)
        subtree = parse_static_string(ctx)
        tree.add(subtree)
        subtree = parse__gen4(ctx)
        tree.add(subtree)
        subtree = parse__gen5(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[132] if x >=0],
      rules[18]
    )
def parse_import_alias(ctx):
    current = ctx.tokens.current()
    rule = table[6][current.id] if current else -1
    tree = ParseTree(NonTerminal(71, 'import_alias'))
    ctx.nonterminal = "import_alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 20: # $import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )
        ctx.rule = rules[20]
        ast_parameters = OrderedDict([
            ('old_name', 1),
            ('new_name', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ImportAlias', ast_parameters)
        t = expect(ctx, 36) # :alias
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 1) # :as
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[71] if x >=0],
      rules[20]
    )
def parse_import_namespace(ctx):
    current = ctx.tokens.current()
    rule = table[1][current.id] if current else -1
    tree = ParseTree(NonTerminal(66, 'import_namespace'))
    ctx.nonterminal = "import_namespace"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 19: # $import_namespace = :as :identifier -> $1
        ctx.rule = rules[19]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 1) # :as
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[66] if x >=0],
      rules[19]
    )
def parse_input_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[59][current.id] if current else -1
    tree = ParseTree(NonTerminal(124, 'input_declaration'))
    ctx.nonterminal = "input_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 50: # $input_declaration = $type_e :identifier $_gen12 -> InputDeclaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[50]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('InputDeclaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        subtree = parse__gen12(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[124] if x >=0],
      rules[50]
    )
def parse_input_kv(ctx):
    current = ctx.tokens.current()
    rule = table[51][current.id] if current else -1
    tree = ParseTree(NonTerminal(116, 'input_kv'))
    ctx.nonterminal = "input_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 82: # $input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[82]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[116] if x >=0],
      rules[82]
    )
def parse_inputs(ctx):
    current = ctx.tokens.current()
    rule = table[63][current.id] if current else -1
    tree = ParseTree(NonTerminal(128, 'inputs'))
    ctx.nonterminal = "inputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 38: # $inputs = :input :lbrace $_gen9 :rbrace -> Inputs( inputs=$2 )
        ctx.rule = rules[38]
        ast_parameters = OrderedDict([
            ('inputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Inputs', ast_parameters)
        t = expect(ctx, 29) # :input
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen9(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[128] if x >=0],
      rules[38]
    )
def parse_kv(ctx):
    current = ctx.tokens.current()
    rule = table[4][current.id] if current else -1
    tree = ParseTree(NonTerminal(69, 'kv'))
    ctx.nonterminal = "kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 42: # $kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )
        ctx.rule = rules[42]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RuntimeAttribute', ast_parameters)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 39) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[69] if x >=0],
      rules[42]
    )
def parse_map_kv(ctx):
    current = ctx.tokens.current()
    rule = table[52][current.id] if current else -1
    tree = ParseTree(NonTerminal(117, 'map_kv'))
    ctx.nonterminal = "map_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 53: # $map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )
        ctx.rule = rules[53]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteralKv', ast_parameters)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 39) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[117] if x >=0],
      rules[53]
    )
def parse_meta(ctx):
    current = ctx.tokens.current()
    rule = table[62][current.id] if current else -1
    tree = ParseTree(NonTerminal(127, 'meta'))
    ctx.nonterminal = "meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 43: # $meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[43]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 34) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[127] if x >=0],
      rules[43]
    )
def parse_meta_kv(ctx):
    current = ctx.tokens.current()
    rule = table[44][current.id] if current else -1
    tree = ParseTree(NonTerminal(109, 'meta_kv'))
    ctx.nonterminal = "meta_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 47: # $meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )
        ctx.rule = rules[47]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaKvPair', ast_parameters)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 39) # :colon
        tree.add(t)
        subtree = parse_meta_value(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[109] if x >=0],
      rules[47]
    )
def parse_meta_map(ctx):
    current = ctx.tokens.current()
    rule = table[23][current.id] if current else -1
    tree = ParseTree(NonTerminal(88, 'meta_map'))
    ctx.nonterminal = "meta_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 46: # $meta_map = :lbrace $_gen11 :rbrace -> $1
        ctx.rule = rules[46]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen11(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[88] if x >=0],
      rules[46]
    )
def parse_object_kv(ctx):
    current = ctx.tokens.current()
    rule = table[39][current.id] if current else -1
    tree = ParseTree(NonTerminal(104, 'object_kv'))
    ctx.nonterminal = "object_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 81: # $object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[81]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 39) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[104] if x >=0],
      rules[81]
    )
def parse_output_kv(ctx):
    current = ctx.tokens.current()
    rule = table[69][current.id] if current else -1
    tree = ParseTree(NonTerminal(134, 'output_kv'))
    ctx.nonterminal = "output_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 56: # $output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )
        ctx.rule = rules[56]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Output', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 9) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[134] if x >=0],
      rules[56]
    )
def parse_outputs(ctx):
    current = ctx.tokens.current()
    rule = table[47][current.id] if current else -1
    tree = ParseTree(NonTerminal(112, 'outputs'))
    ctx.nonterminal = "outputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 55: # $outputs = :output :lbrace $_gen13 :rbrace -> Outputs( outputs=$2 )
        ctx.rule = rules[55]
        ast_parameters = OrderedDict([
            ('outputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Outputs', ast_parameters)
        t = expect(ctx, 25) # :output
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen13(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[112] if x >=0],
      rules[55]
    )
def parse_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[28][current.id] if current else -1
    tree = ParseTree(NonTerminal(93, 'parameter_meta'))
    ctx.nonterminal = "parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 44: # $parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[44]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 7) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[93] if x >=0],
      rules[44]
    )
def parse_rt_map(ctx):
    current = ctx.tokens.current()
    rule = table[64][current.id] if current else -1
    tree = ParseTree(NonTerminal(129, 'rt_map'))
    ctx.nonterminal = "rt_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 41: # $rt_map = :lbrace $_gen10 :rbrace -> $1
        ctx.rule = rules[41]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen10(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[129] if x >=0],
      rules[41]
    )
def parse_runtime(ctx):
    current = ctx.tokens.current()
    rule = table[54][current.id] if current else -1
    tree = ParseTree(NonTerminal(119, 'runtime'))
    ctx.nonterminal = "runtime"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 39: # $runtime = :runtime $rt_map -> Runtime( map=$1 )
        ctx.rule = rules[39]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Runtime', ast_parameters)
        t = expect(ctx, 18) # :runtime
        tree.add(t)
        subtree = parse_rt_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[119] if x >=0],
      rules[39]
    )
def parse_scatter(ctx):
    current = ctx.tokens.current()
    rule = table[36][current.id] if current else -1
    tree = ParseTree(NonTerminal(101, 'scatter'))
    ctx.nonterminal = "scatter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 80: # $scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen14 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )
        ctx.rule = rules[80]
        ast_parameters = OrderedDict([
            ('item', 2),
            ('collection', 4),
            ('body', 7),
        ])
        tree.astTransform = AstTransformNodeCreator('Scatter', ast_parameters)
        t = expect(ctx, 3) # :scatter
        tree.add(t)
        t = expect(ctx, 0) # :lparen
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 51) # :in
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 48) # :rparen
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[101] if x >=0],
      rules[80]
    )
def parse_setter(ctx):
    current = ctx.tokens.current()
    rule = table[55][current.id] if current else -1
    tree = ParseTree(NonTerminal(120, 'setter'))
    ctx.nonterminal = "setter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 52: # $setter = :equal $e -> $1
        ctx.rule = rules[52]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 9) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[120] if x >=0],
      rules[52]
    )
def parse_static_string(ctx):
    current = ctx.tokens.current()
    rule = table[35][current.id] if current else -1
    tree = ParseTree(NonTerminal(100, 'static_string'))
    ctx.nonterminal = "static_string"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 10: # $static_string = :quote :string :quote -> $1
        ctx.rule = rules[10]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 33) # :quote
        tree.add(t)
        t = expect(ctx, 49) # :string
        tree.add(t)
        t = expect(ctx, 33) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[100] if x >=0],
      rules[10]
    )
def parse_string_literal(ctx):
    current = ctx.tokens.current()
    rule = table[42][current.id] if current else -1
    tree = ParseTree(NonTerminal(107, 'string_literal'))
    ctx.nonterminal = "string_literal"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 12: # $string_literal = :quote $_gen3 :quote -> StringLiteral( pieces=$1 )
        ctx.rule = rules[12]
        ast_parameters = OrderedDict([
            ('pieces', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StringLiteral', ast_parameters)
        t = expect(ctx, 33) # :quote
        tree.add(t)
        subtree = parse__gen3(ctx)
        tree.add(subtree)
        t = expect(ctx, 33) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[107] if x >=0],
      rules[12]
    )
def parse_string_piece(ctx):
    current = ctx.tokens.current()
    rule = table[2][current.id] if current else -1
    tree = ParseTree(NonTerminal(67, 'string_piece'))
    ctx.nonterminal = "string_piece"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 13: # $string_piece = :string
        ctx.rule = rules[13]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 49) # :string
        tree.add(t)
        return tree
    elif rule == 14: # $string_piece = $expression_placeholder
        ctx.rule = rules[14]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[67] if x >=0],
      rules[14]
    )
def parse_struct(ctx):
    current = ctx.tokens.current()
    rule = table[30][current.id] if current else -1
    tree = ParseTree(NonTerminal(95, 'struct'))
    ctx.nonterminal = "struct"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 8: # $struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )
        ctx.rule = rules[8]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('entries', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Struct', ast_parameters)
        t = expect(ctx, 31) # :struct
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen2(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[95] if x >=0],
      rules[8]
    )
def parse_struct_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[10][current.id] if current else -1
    tree = ParseTree(NonTerminal(75, 'struct_declaration'))
    ctx.nonterminal = "struct_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 9: # $struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )
        ctx.rule = rules[9]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StructEntry', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[75] if x >=0],
      rules[9]
    )
def parse_task(ctx):
    current = ctx.tokens.current()
    rule = table[41][current.id] if current else -1
    tree = ParseTree(NonTerminal(106, 'task'))
    ctx.nonterminal = "task"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 22: # $task = :task :identifier :lbrace $_gen6 :rbrace -> Task( name=$1, sections=$3 )
        ctx.rule = rules[22]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('sections', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Task', ast_parameters)
        t = expect(ctx, 50) # :task
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen6(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[106] if x >=0],
      rules[22]
    )
def parse_task_sections(ctx):
    current = ctx.tokens.current()
    rule = table[26][current.id] if current else -1
    tree = ParseTree(NonTerminal(91, 'task_sections'))
    ctx.nonterminal = "task_sections"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 23: # $task_sections = $command
        ctx.rule = rules[23]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_command(ctx)
        tree.add(subtree)
        return tree
    elif rule == 24: # $task_sections = $inputs
        ctx.rule = rules[24]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 25: # $task_sections = $outputs
        ctx.rule = rules[25]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 26: # $task_sections = $runtime
        ctx.rule = rules[26]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_runtime(ctx)
        tree.add(subtree)
        return tree
    elif rule == 27: # $task_sections = $parameter_meta
        ctx.rule = rules[27]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 28: # $task_sections = $meta
        ctx.rule = rules[28]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 29: # $task_sections = $declaration
        ctx.rule = rules[29]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[91] if x >=0],
      rules[29]
    )
def parse_version(ctx):
    current = ctx.tokens.current()
    rule = table[49][current.id] if current else -1
    tree = ParseTree(NonTerminal(114, 'version'))
    ctx.nonterminal = "version"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 6: # $version = :version :version_name -> VersionDeclaration( v=$1 )
        ctx.rule = rules[6]
        ast_parameters = OrderedDict([
            ('v', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('VersionDeclaration', ast_parameters)
        t = expect(ctx, 59) # :version
        tree.add(t)
        t = expect(ctx, 55) # :version_name
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[114] if x >=0],
      rules[6]
    )
def parse_wf_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[66][current.id] if current else -1
    tree = ParseTree(NonTerminal(131, 'wf_body_element'))
    ctx.nonterminal = "wf_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 59: # $wf_body_element = $call
        ctx.rule = rules[59]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call(ctx)
        tree.add(subtree)
        return tree
    elif rule == 60: # $wf_body_element = $declaration
        ctx.rule = rules[60]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    elif rule == 61: # $wf_body_element = $while_loop
        ctx.rule = rules[61]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_while_loop(ctx)
        tree.add(subtree)
        return tree
    elif rule == 62: # $wf_body_element = $if_stmt
        ctx.rule = rules[62]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_if_stmt(ctx)
        tree.add(subtree)
        return tree
    elif rule == 63: # $wf_body_element = $scatter
        ctx.rule = rules[63]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_scatter(ctx)
        tree.add(subtree)
        return tree
    elif rule == 64: # $wf_body_element = $inputs
        ctx.rule = rules[64]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 65: # $wf_body_element = $outputs
        ctx.rule = rules[65]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 66: # $wf_body_element = $wf_parameter_meta
        ctx.rule = rules[66]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 67: # $wf_body_element = $wf_meta
        ctx.rule = rules[67]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_meta(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[131] if x >=0],
      rules[67]
    )
def parse_wf_meta(ctx):
    current = ctx.tokens.current()
    rule = table[68][current.id] if current else -1
    tree = ParseTree(NonTerminal(133, 'wf_meta'))
    ctx.nonterminal = "wf_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 77: # $wf_meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[77]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 34) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[133] if x >=0],
      rules[77]
    )
def parse_wf_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[11][current.id] if current else -1
    tree = ParseTree(NonTerminal(76, 'wf_parameter_meta'))
    ctx.nonterminal = "wf_parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 76: # $wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[76]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 7) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[76] if x >=0],
      rules[76]
    )
def parse_while_loop(ctx):
    current = ctx.tokens.current()
    rule = table[7][current.id] if current else -1
    tree = ParseTree(NonTerminal(72, 'while_loop'))
    ctx.nonterminal = "while_loop"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 78: # $while_loop = :while :lparen $e :rparen :lbrace $_gen14 :rbrace -> WhileLoop( expression=$2, body=$5 )
        ctx.rule = rules[78]
        ast_parameters = OrderedDict([
            ('expression', 2),
            ('body', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('WhileLoop', ast_parameters)
        t = expect(ctx, 41) # :while
        tree.add(t)
        t = expect(ctx, 0) # :lparen
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 48) # :rparen
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[72] if x >=0],
      rules[78]
    )
def parse_workflow(ctx):
    current = ctx.tokens.current()
    rule = table[29][current.id] if current else -1
    tree = ParseTree(NonTerminal(94, 'workflow'))
    ctx.nonterminal = "workflow"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 58: # $workflow = :workflow :identifier :lbrace $_gen14 :rbrace -> Workflow( name=$1, body=$3 )
        ctx.rule = rules[58]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Workflow', ast_parameters)
        t = expect(ctx, 30) # :workflow
        tree.add(t)
        t = expect(ctx, 54) # :identifier
        tree.add(t)
        t = expect(ctx, 8) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 56) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[94] if x >=0],
      rules[58]
    )
# Lexer Code #
# START USER CODE
def init():
    return {
        'context': None,
        'replacements': {
            re.compile(r"\\n"): 0x000A,
            re.compile(r"\\r"): 0x000D,
            re.compile(r"\\b"): 0x0008,
            re.compile(r"\\t"): 0x0009,
            re.compile(r"\\a"): 0x0007,
            re.compile(r"\\v"): 0x000B,
            re.compile(r'\\"'): 0x0022,
            re.compile(r"\\'"): 0x0027,
            re.compile(r"\\\?"): 0x003F
        },
        'escapes': {
            re.compile(r'(\\([0-7]{1,3}))'): 8,
            re.compile(r'(\\[xX]([0-9a-fA-F]{1,4}))'): 16,
            re.compile(r'(\\[uU]([0-9a-fA-F]{4}))'): 16
        }
    }
def workflow(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'workflow'
    default_action(ctx, terminal, source_string, line, col)
def task(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'task'
    default_action(ctx, terminal, source_string, line, col)
def output(ctx, terminal, source_string, line, col):
    if ctx.user_context['context'] == 'workflow':
        ctx.stack.append('wf_output')
    default_action(ctx, terminal, source_string, line, col)
def wdl_unescape(ctx, terminal, source_string, line, col):
    for regex, c in ctx.user_context['replacements'].items():
        source_string = regex.sub(chr(c), source_string)
    source_string = source_string.replace("\u005C\u005C", "\u005C")
    for regex, base in ctx.user_context['escapes'].items():
        for escape_sequence, number in regex.findall(source_string):
            source_string = source_string.replace(escape_sequence, chr(int(number, base)))
    default_action(ctx, terminal, source_string[1:-1], line, col)
# END USER CODE
def emit(ctx, terminal, source_string, line, col):
    if terminal:
        ctx.tokens.append(Terminal(terminals[terminal], terminal, source_string, ctx.resource, line, col))
def default_action(ctx, terminal, source_string, line, col):
    emit(ctx, terminal, source_string, line, col)
def post_filter(tokens):
    return tokens
def destroy(context):
    pass
class LexerStackPush:
    def __init__(self, mode):
        self.mode = mode
class LexerAction:
    def __init__(self, action):
        self.action = action
class LexerContext:
    def __init__(self, string, resource, errors, user_context):
        self.__dict__.update(locals())
        self.stack = ['default']
        self.line = 1
        self.col = 1
        self.tokens = []
        self.user_context = user_context
        self.re_match = None # https://docs.python.org/3/library/re.html#match-objects
class HermesLexer:
    regex = {
        'default': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'/\*(.*?)\*/', re.DOTALL), [
              # (terminal, group, function)
          ]),
          (re.compile(r'#.*'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'version\s+'), [
              # (terminal, group, function)
              ('version', 0, None),
              LexerStackPush('awaiting_version_name'),
          ]),
          (re.compile(r'task(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('task', 0, task),
          ]),
          (re.compile(r'(call)\s+'), [
              # (terminal, group, function)
              ('call', 1, None),
              LexerStackPush('task_fqn'),
          ]),
          (re.compile(r'workflow(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('workflow', 0, workflow),
          ]),
          (re.compile(r'struct(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('struct', 0, None),
          ]),
          (re.compile(r'import(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('import', 0, None),
          ]),
          (re.compile(r'alias(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('alias', 0, None),
          ]),
          (re.compile(r'input(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('input', 0, None),
          ]),
          (re.compile(r'output(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('output', 0, None),
          ]),
          (re.compile(r'as(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('as', 0, None),
          ]),
          (re.compile(r'if(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'then(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'else(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'while(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('while', 0, None),
          ]),
          (re.compile(r'runtime(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('runtime', 0, None),
          ]),
          (re.compile(r'scatter(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('scatter', 0, None),
              LexerStackPush('scatter'),
          ]),
          (re.compile(r'command\s*(?=<<<)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command2'),
          ]),
          (re.compile(r'command\s*(?=\{)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command'),
          ]),
          (re.compile(r'parameter_meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('parameter_meta', 0, None),
          ]),
          (re.compile(r'meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('meta', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(object)\s*(\{)'), [
              # (terminal, group, function)
              ('object', 0, None),
              ('lbrace', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r'null'), [
              # (terminal, group, function)
              ('null', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('rbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'\?'), [
              # (terminal, group, function)
              ('qmark', 0, None),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
        'dquote_string': OrderedDict([
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'[^\"\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, None),
          ]),
        ]),
        'squote_string': OrderedDict([
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'[^\'\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, None),
          ]),
        ]),
        'awaiting_version_name': OrderedDict([
          (re.compile(r'draft-3'), [
              # (terminal, group, function)
              ('version_name', 0, None),
              LexerAction('pop'),
          ]),
        ]),
        'task_fqn': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(\.[a-zA-Z]([a-zA-Z0-9_])*)*'), [
              # (terminal, group, function)
              ('fqn', 0, None),
              LexerAction('pop'),
          ]),
        ]),
        'scatter': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'in(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('in', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
        ]),
        'raw_command': OrderedDict([
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=\$\{|~\{|\})', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'raw_command2': OrderedDict([
          (re.compile(r'<<<'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'>>>'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=~\{|>>>)', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'expression_placeholder': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('expression_placeholder_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
          (re.compile(r'if'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'else'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'then'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(?=\s*=)'), [
              # (terminal, group, function)
              ('cmd_attr_hint', None, None),
              ('identifier', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
    }
    def _advance_line_col(self, string, length, line, col):
        for i in range(length):
            if string[i] == '\n':
                line += 1
                col = 1
            else:
                col += 1
        return (line, col)
    def _advance_string(self, ctx, string):
        (ctx.line, ctx.col) = self._advance_line_col(string, len(string), ctx.line, ctx.col)
        ctx.string = ctx.string[len(string):]
    def _next(self, ctx, debug=False):
        for regex, outputs in self.regex[ctx.stack[-1]].items():
            if debug:
                from xtermcolor import colorize
                token_count = len(ctx.tokens)
                print('{1} ({2}, {3}) regex: {0}'.format(
                    colorize(regex.pattern, ansi=40), colorize(ctx.string[:20].replace('\n', '\\n'), ansi=15), ctx.line, ctx.col)
                )
            match = regex.match(ctx.string)
            if match:
                ctx.re_match = match
                for output in outputs:
                    if isinstance(output, tuple):
                        (terminal, group, function) = output
                        function = function if function else default_action
                        source_string = match.group(group) if group is not None else ''
                        (group_line, group_col) = self._advance_line_col(ctx.string, match.start(group) if group else 0, ctx.line, ctx.col)
                        function(
                            ctx,
                            terminal,
                            source_string,
                            group_line,
                            group_col
                        )
                        if debug:
                            print('    matched: {}'.format(colorize(match.group(0).replace('\n', '\\n'), ansi=3)))
                            for token in ctx.tokens[token_count:]:
                                print('    emit: [{}] [{}, {}] [{}] stack:{} context:{}'.format(
                                    colorize(token.str, ansi=9),
                                    colorize(str(token.line), ansi=5),
                                    colorize(str(token.col), ansi=5),
                                    colorize(token.source_string, ansi=3),
                                    colorize(str(ctx.stack), ansi=4),
                                    colorize(str(ctx.user_context), ansi=13)
                                ))
                            token_count = len(ctx.tokens)
                    if isinstance(output, LexerStackPush):
                        ctx.stack.append(output.mode)
                        if debug:
                            print('    push on stack: {}'.format(colorize(output.mode, ansi=4)))
                    if isinstance(output, LexerAction):
                        if output.action == 'pop':
                            mode = ctx.stack.pop()
                            if debug:
                                print('    pop off stack: {}'.format(colorize(mode, ansi=4)))
                self._advance_string(ctx, match.group(0))
                return len(match.group(0)) > 0
        return False
    def lex(self, string, resource, errors=None, debug=False):
        if errors is None:
            errors = DefaultSyntaxErrorHandler()
        string_copy = string
        user_context = init()
        ctx = LexerContext(string, resource, errors, user_context)
        while len(ctx.string):
            matched = self._next(ctx, debug)
            if matched == False:
                raise ctx.errors.unrecognized_token(string_copy, ctx.line, ctx.col)
        destroy(ctx.user_context)
        filtered = post_filter(ctx.tokens)
        return filtered
def lex(source, resource, errors=None, debug=False):
    return TokenStream(HermesLexer().lex(source, resource, errors, debug))
