
# This file was generated by Hermes Parser Generator on Wed Dec 19 05:52:44 2018
# 
# Hermes command: hermes generate wdl/versions/1.0/parsers/grammar.hgr --language=python --name=version_1_0 --header --directory wdl_parser
# Run from: .. (relative to this file)
# Hermes version: hermes-parser 2.0rc6
# 
# !!! DO NOT CHANGE THIS FILE DIRECTLY !!!
# 
# If you wish to change something in this file, either change the grammar and
# re-generate this file, or change the templates in Hermes and regenerate.
# See the Hermes repository: http://github.com/scottfrazer/hermes
import sys
import os
import re
import base64
import argparse
from collections import OrderedDict
# Common Code #
def parse_tree_string(parsetree, indent=None, b64_source=True, indent_level=0, debug=False):
    indent_str = (' ' * indent * indent_level) if indent else ''
    if isinstance(parsetree, ParseTree):
        children = [parse_tree_string(child, indent, b64_source, indent_level+1, debug) for child in parsetree.children]
        debug_str = parsetree.debug_str() if debug else ''
        if indent is None or len(children) == 0:
            return '{0}({1}: {2}{3})'.format(indent_str, parsetree.nonterminal, debug_str, ', '.join(children))
        else:
            return '{0}({1}:{2}\n{3}\n{4})'.format(
                indent_str,
                parsetree.nonterminal,
                debug_str,
                ',\n'.join(children),
                indent_str
            )
    elif isinstance(parsetree, Terminal):
        return indent_str + parsetree.dumps(b64_source=b64_source)
def ast_string(ast, indent=None, b64_source=True, indent_level=0):
    indent_str = (' ' * indent * indent_level) if indent else ''
    next_indent_str = (' ' * indent * (indent_level+1)) if indent else ''
    if isinstance(ast, Ast):
        children = OrderedDict([(k, ast_string(v, indent, b64_source, indent_level+1)) for k, v in ast.attributes.items()])
        if indent is None:
            return '({0}: {1})'.format(
                ast.name,
                ', '.join('{0}={1}'.format(k, v) for k, v in children.items())
            )
        else:
            return '({0}:\n{1}\n{2})'.format(
                ast.name,
                ',\n'.join(['{0}{1}={2}'.format(next_indent_str, k, v) for k, v in children.items()]),
                indent_str
            )
    elif isinstance(ast, list):
        children = [ast_string(element, indent, b64_source, indent_level+1) for element in ast]
        if indent is None or len(children) == 0:
            return '[{0}]'.format(', '.join(children))
        else:
            return '[\n{1}\n{0}]'.format(
                indent_str,
                ',\n'.join(['{0}{1}'.format(next_indent_str, child) for child in children]),
            )
    elif isinstance(ast, Terminal):
        return ast.dumps(b64_source=b64_source)
class Terminal:
  def __init__(self, id, str, source_string, resource, line, col):
      self.__dict__.update(locals())
  def getId(self):
      return self.id
  def ast(self):
      return self
  def dumps(self, b64_source=True, **kwargs):
      source_string = base64.b64encode(self.source_string.encode('utf-8')).decode('utf-8') if b64_source else self.source_string
      return '<{resource}:{line}:{col} {terminal} "{source}">'.format(
          resource=self.resource,
          line=self.line,
          col=self.col,
          terminal=self.str,
          source=source_string
      )
  def __str__(self):
      return self.dumps()
class NonTerminal():
  def __init__(self, id, str):
    self.__dict__.update(locals())
    self.list = False
  def __str__(self):
    return self.str
class AstTransform:
  pass
class AstTransformSubstitution(AstTransform):
  def __init__(self, idx):
    self.__dict__.update(locals())
  def __repr__(self):
    return '$' + str(self.idx)
  def __str__(self):
    return self.__repr__()
class AstTransformNodeCreator(AstTransform):
  def __init__( self, name, parameters ):
    self.__dict__.update(locals())
  def __repr__( self ):
    return self.name + '( ' + ', '.join(['%s=$%s' % (k,str(v)) for k,v in self.parameters.items()]) + ' )'
  def __str__(self):
    return self.__repr__()
class AstList(list):
  def ast(self):
      retval = []
      for ast in self:
          retval.append(ast.ast())
      return retval
  def dumps(self, indent=None, b64_source=True):
      args = locals()
      del args['self']
      return ast_string(self, **args)
class ParseTree():
  def __init__(self, nonterminal):
      self.__dict__.update(locals())
      self.children = []
      self.astTransform = None
      self.isExpr = False
      self.isNud = False
      self.isPrefix = False
      self.isInfix = False
      self.nudMorphemeCount = 0
      self.isExprNud = False # true for rules like _expr := {_expr} + {...}
      self.list_separator_id = None
      self.list = False
  def debug_str(self):
      from copy import deepcopy
      def h(v):
          if v == False or v is None:
              return str(v)
          from xtermcolor import colorize
          return colorize(str(v), ansi=190)
      d = deepcopy(self.__dict__)
      for key in ['self', 'nonterminal', 'children']:
          del d[key]
      f = {k: v for k, v in d.items() if v != False and v is not None}
      return ' [{}]'.format(', '.join(['{}={}'.format(k,h(v)) for k,v in f.items()]))
  def add(self, tree):
      self.children.append( tree )
  def is_compound_nud(self):
      return isinstance(self.children[0], ParseTree) and \
             self.children[0].isNud and \
             not self.children[0].isPrefix and \
             not self.isExprNud and \
             not self.isInfix
  def ast(self):
      if self.list == True:
          r = AstList()
          if len(self.children) == 0:
              return r
          for child in self.children:
              if isinstance(child, Terminal) and self.list_separator_id is not None and child.id == self.list_separator_id:
                  continue
              r.append(child.ast())
          return r
      elif self.isExpr:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  if idx == '$':
                      child = self.children[0]
                  elif self.is_compound_nud():
                      if idx < self.children[0].nudMorphemeCount:
                          child = self.children[0].children[idx]
                      else:
                          index = idx - self.children[0].nudMorphemeCount + 1
                          child = self.children[index]
                  elif len(self.children) == 1 and not isinstance(self.children[0], ParseTree) and not isinstance(self.children[0], list):
                      return self.children[0]
                  else:
                      child = self.children[idx]
                  parameters[name] = child.ast()
              return Ast(self.astTransform.name, parameters)
      else:
          if isinstance(self.astTransform, AstTransformSubstitution):
              return self.children[self.astTransform.idx].ast()
          elif isinstance(self.astTransform, AstTransformNodeCreator):
              parameters = OrderedDict()
              for name, idx in self.astTransform.parameters.items():
                  parameters[name] = self.children[idx].ast()
              return Ast(self.astTransform.name, parameters)
          elif len(self.children):
              return self.children[0].ast()
          else:
              return None
  def dumps(self, indent=None, b64_source=True, debug=False):
      args = locals()
      del args['self']
      return parse_tree_string(self, **args)
class Ast():
    def __init__(self, name, attributes):
        self.__dict__.update(locals())
    def attr(self, attr):
        return self.attributes[attr]
    def dumps(self, indent=None, b64_source=True):
        args = locals()
        del args['self']
        return ast_string(self, **args)
class SyntaxError(Exception):
    def __init__(self, message):
        self.__dict__.update(locals())
    def __str__(self):
        return self.message
class TokenStream(list):
    def __init__(self, arg=[]):
        super(TokenStream, self).__init__(arg)
        self.index = 0
    def advance(self):
        self.index += 1
        return self.current()
    def last(self):
        return self[-1]
    def current(self):
        try:
            return self[self.index]
        except IndexError:
            return None
class DefaultSyntaxErrorHandler:
    def __init__(self):
        self.errors = []
    def _error(self, string):
        error = SyntaxError(string)
        self.errors.append(error)
        return error
    def unexpected_eof(self):
        return self._error("Error: unexpected end of file")
    def excess_tokens(self):
        return self._error("Finished parsing without consuming all tokens.")
    def unexpected_symbol(self, nonterminal, actual_terminal, expected_terminals, rule):
        return self._error("Unexpected symbol (line {line}, col {col}) when parsing parse_{nt}.  Expected {expected}, got {actual}.".format(
            line=actual_terminal.line,
            col=actual_terminal.col,
            nt=nonterminal,
            expected=', '.join(expected_terminals),
            actual=actual_terminal
        ))
    def no_more_tokens(self, nonterminal, expected_terminal, last_terminal):
        return self._error("No more tokens.  Expecting " + expected_terminal)
    def invalid_terminal(self, nonterminal, invalid_terminal):
        return self._error("Invalid symbol ID: {} ({})".format(invalid_terminal.id, invalid_terminal.string))
    def unrecognized_token(self, string, line, col):
        lines = string.split('\n')
        bad_line = lines[line-1]
        return self._error('Unrecognized token on line {}, column {}:\n\n{}\n{}'.format(
            line, col, bad_line, ''.join([' ' for x in range(col-1)]) + '^'
        ))
    def missing_list_items(self, method, required, found, last):
        return self._error("List for {} requires {} items but only {} were found.".format(method, required, found))
    def missing_terminator(self, method, terminator, last):
        return self._error("List for "+method+" is missing a terminator")
class ParserContext:
  def __init__(self, tokens, errors):
    self.__dict__.update(locals())
    self.nonterminal_string = None
    self.rule_string = None
# Parser Code #
terminals = {
    0: 'workflow',
    1: 'scatter',
    2: 'comma',
    3: 'in',
    4: 'boolean',
    5: 'double_ampersand',
    6: 'lsquare',
    7: 'rbrace',
    8: 'cmd_part',
    9: 'version',
    10: 'raw_cmd_end',
    11: 'parameter_meta',
    12: 'raw_cmd_start',
    13: 'double_equal',
    14: 'double_pipe',
    15: 'meta',
    16: 'gteq',
    17: 'string',
    18: 'task',
    19: 'cmd_attr_hint',
    20: 'lbrace',
    21: 'input',
    22: 'lparen',
    23: 'lt',
    24: 'identifier',
    25: 'if',
    26: 'integer',
    27: 'float',
    28: 'equal',
    29: 'not_equal',
    30: 'expression_placeholder_start',
    31: 'slash',
    32: 'object',
    33: 'fqn',
    34: 'alias',
    35: 'output',
    36: 'lteq',
    37: 'import',
    38: 'gt',
    39: 'rparen',
    40: 'else',
    41: 'plus',
    42: 'not',
    43: 'then',
    44: 'struct',
    45: 'call',
    46: 'null',
    47: 'quote',
    48: 'dot',
    49: 'rsquare',
    50: 'colon',
    51: 'type',
    52: 'while',
    53: 'type_e',
    54: 'e',
    55: 'expression_placeholder_end',
    56: 'asterisk',
    57: 'as',
    58: 'qmark',
    59: 'dash',
    60: 'raw_command',
    61: 'version_name',
    62: 'runtime',
    63: 'percent',
    64: 'meta_value',
    'workflow': 0,
    'scatter': 1,
    'comma': 2,
    'in': 3,
    'boolean': 4,
    'double_ampersand': 5,
    'lsquare': 6,
    'rbrace': 7,
    'cmd_part': 8,
    'version': 9,
    'raw_cmd_end': 10,
    'parameter_meta': 11,
    'raw_cmd_start': 12,
    'double_equal': 13,
    'double_pipe': 14,
    'meta': 15,
    'gteq': 16,
    'string': 17,
    'task': 18,
    'cmd_attr_hint': 19,
    'lbrace': 20,
    'input': 21,
    'lparen': 22,
    'lt': 23,
    'identifier': 24,
    'if': 25,
    'integer': 26,
    'float': 27,
    'equal': 28,
    'not_equal': 29,
    'expression_placeholder_start': 30,
    'slash': 31,
    'object': 32,
    'fqn': 33,
    'alias': 34,
    'output': 35,
    'lteq': 36,
    'import': 37,
    'gt': 38,
    'rparen': 39,
    'else': 40,
    'plus': 41,
    'not': 42,
    'then': 43,
    'struct': 44,
    'call': 45,
    'null': 46,
    'quote': 47,
    'dot': 48,
    'rsquare': 49,
    'colon': 50,
    'type': 51,
    'while': 52,
    'type_e': 53,
    'e': 54,
    'expression_placeholder_end': 55,
    'asterisk': 56,
    'as': 57,
    'qmark': 58,
    'dash': 59,
    'raw_command': 60,
    'version_name': 61,
    'runtime': 62,
    'percent': 63,
    'meta_value': 64,
}
# table[nonterminal][terminal] = rule
table = [
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 40, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 48, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 73, -1, -1, -1, -1, -1, 73, -1, -1, -1, 73, -1, -1, -1, 73, -1, -1, -1, -1, 72, 73, -1, -1, 73, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, 73, -1, -1, -1, -1, -1, 73, 73, 73, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 44, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, -1, -1, 50, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 51, -1, 51, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 58, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 58, -1, 58, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 57, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 45, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 52, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 52, -1, 52, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 82, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 46, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 9, -1, 9, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 14, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 71, -1, -1, -1, -1, -1, 71, -1, -1, -1, 71, -1, -1, -1, 71, -1, -1, -1, -1, 71, 71, -1, -1, 71, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, -1, -1, -1, -1, -1, -1, -1, -1, 71, -1, -1, -1, -1, -1, 71, 71, 71, -1, -1, -1, 70, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 83, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, 2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [18, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, 18, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 17, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 41, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, 34, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, 65, -1, -1, -1, -1, -1, -1, -1, -1, -1, 68, -1, -1, -1, 69, -1, -1, -1, -1, -1, 66, -1, -1, 62, 64, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67, -1, -1, -1, -1, -1, -1, -1, -1, -1, 61, -1, -1, -1, -1, -1, 62, 63, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 77, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 74, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 29, -1, -1, -1, 30, -1, -1, -1, -1, -1, 26, -1, -1, 31, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 27, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 31, -1, 31, -1, -1, -1, -1, -1, -1, 25, -1, 28, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 84, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, 55, -1, 55, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55, -1, 55, -1, 55, 55, 55, 55, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1, -1, -1, -1, 55, 55, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1, -1, 55, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 22, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 81, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 43, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 80, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 76, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, -1, -1, -1, -1, -1, -1, -1],
    [60, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 12, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 53, -1, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
]
nonterminal_first = {
    65: [19, -1],
    66: [44],
    67: [21, 51, 24, 35, 53, 11, 15, -1, 60, 62],
    68: [21],
    69: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    70: [20],
    71: [24, -1, 51, 53],
    72: [20, -1],
    73: [24, -1],
    74: [34, -1],
    75: [-1, 30, 8],
    76: [24],
    77: [28, -1],
    78: [24, 51, 53],
    79: [11],
    80: [35],
    81: [15],
    82: [24, 51, 53],
    83: [18, 44, 0],
    84: [1],
    85: [11],
    86: [24, 51, 53],
    87: [60],
    88: [47],
    89: [57, -1],
    90: [24, -1],
    91: [24, -1],
    92: [4, 6, 41, 42, 47, 20, 22, 24, 25, 54, 26, 27, 59, -1, 32],
    93: [24],
    94: [18],
    95: [24, -1, 51, 53],
    96: [9],
    97: [57, -1],
    98: [62],
    99: [24, -1, 51, 53],
    100: [30, 8],
    101: [28],
    102: [24, -1, 51, 53],
    103: [21, 1, 24, 51, 53, 25, 52, 35, 11, 15, 45],
    104: [37, -1],
    105: [57],
    106: [30],
    107: [15],
    108: [17, -1],
    109: [24, 51, 53],
    110: [17, 30],
    111: [1, 35, 11, 15, 45, 21, 24, 51, 53, 25, 52, -1],
    112: [27, 64, 20, 46, 4, 6, 26, 47],
    113: [4, 6, 46, 47, 20, 26, 27, -1, 64],
    114: [45],
    115: [21, 51, 24, 35, 53, 11, 15, 60, 62],
    116: [24],
    117: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    118: [34],
    119: [37],
    120: [25],
    121: [24, -1],
    122: [20],
    123: [52],
    124: [20],
    125: [9],
    126: [57],
    127: [0],
    128: [24],
    129: [0, 18, 44, -1],
    130: [4, 6, 41, 42, 47, 20, 22, 24, 25, 54, 26, 27, 59, -1, 32],
    131: [47],
    132: [24, -1],
    133: [-1, 17, 30],
    134: [19],
    135: [24, 51, 53],
}
nonterminal_follow = {
    65: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    66: [-1, 0, 18, 44],
    67: [7],
    68: [1, 35, 7, 11, 15, 45, 21, 51, 24, 53, 25, 52, 60, 62],
    69: [1, 5, 2, 4, 6, 16, 11, 13, 7, 14, 15, 19, 20, 21, 22, 23, 24, 25, 26, 27, 29, 31, 32, 35, 36, 38, 40, 39, 41, 42, 43, 45, 48, 47, 49, 50, 51, 53, 54, 52, 55, 56, 59, 60, 62, 63],
    70: [1, 35, 7, 11, 15, 45, 21, 51, 24, 53, 25, 52, 60, 62],
    71: [49],
    72: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    73: [7],
    74: [37, -1, 0, 18, 44],
    75: [10],
    76: [24, 7],
    77: [51, 24, 53, 7],
    78: [51, 24, 53, 7],
    79: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    80: [1, 35, 7, 11, 15, 45, 21, 51, 24, 53, 25, 52, 60, 62],
    81: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    82: [51, 24, 53, 7],
    83: [-1, 0, 18, 44],
    84: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    85: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    86: [51, 24, 53, 7],
    87: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    88: [1, 5, 2, 4, 6, 16, 11, 13, 7, 14, 15, 19, 20, 21, 22, 23, 24, 25, 26, 27, 29, 31, 32, 35, 36, 38, 40, 39, 41, 42, 43, 45, 48, 47, 49, 50, 51, 53, 54, 52, 55, 56, 59, 60, 62, 63],
    89: [1, 35, 7, 11, 15, 45, 20, 21, 24, 51, 53, 25, 52],
    90: [7],
    91: [7],
    92: [39, 49],
    93: [2, 7],
    94: [-1, 0, 18, 44],
    95: [7],
    96: [-1],
    97: [37, -1, 0, 18, 34, 44],
    98: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    99: [7],
    100: [10, 30, 8],
    101: [1, 35, 7, 11, 15, 45, 21, 51, 24, 53, 25, 52, 60, 62],
    102: [7],
    103: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    104: [-1, 18, 44, 0],
    105: [1, 35, 7, 11, 15, 45, 20, 21, 24, 51, 53, 25, 52],
    106: [10, 47, 17, 30, 8],
    107: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    108: [47],
    109: [24, 2, 49],
    110: [17, 30, 47],
    111: [7],
    112: [49, 24, 2, 7],
    113: [49],
    114: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    115: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    116: [2, 7],
    117: [2, 7],
    118: [-1, 0, 34, 37, 18, 44],
    119: [37, -1, 0, 18, 44],
    120: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    121: [7],
    122: [21, 51, 24, 35, 53, 11, 7, 15, 60, 62],
    123: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    124: [1, 35, 7, 11, 15, 45, 21, 24, 51, 53, 25, 52],
    125: [37, -1],
    126: [-1, 0, 34, 37, 18, 44],
    127: [-1, 0, 18, 44],
    128: [24, 2, 7],
    129: [-1],
    130: [7],
    131: [-1, 49, 0, 24, 7, 37, 57, 18, 2, 44],
    132: [7],
    133: [47],
    134: [4, 6, 41, 42, 19, 47, 20, 22, 24, 25, 54, 26, 27, 59, 32],
    135: [1, 35, 7, 11, 15, 45, 21, 51, 24, 53, 25, 52, 60, 62],
}
rule_first = {
    0: [37, -1],
    1: [-1, 18, 44, 0],
    2: [9],
    3: [0],
    4: [18],
    5: [44],
    6: [9],
    7: [24, 51, 53, -1],
    8: [44],
    9: [51, 24, 53],
    10: [17],
    11: [-1],
    12: [47],
    13: [17, 30, -1],
    14: [47],
    15: [17],
    16: [30],
    17: [57],
    18: [-1],
    19: [34, -1],
    20: [37],
    21: [57],
    22: [34],
    23: [21, 51, 24, 35, 53, 11, 15, -1, 60, 62],
    24: [18],
    25: [60],
    26: [21],
    27: [35],
    28: [62],
    29: [11],
    30: [15],
    31: [51, 24, 53],
    32: [-1, 30, 8],
    33: [60],
    34: [8],
    35: [30],
    36: [-1, 19],
    37: [30],
    38: [19],
    39: [24, 51, 53, -1],
    40: [21],
    41: [62],
    42: [24, -1],
    43: [20],
    44: [24],
    45: [15],
    46: [11],
    47: [24, -1],
    48: [20],
    49: [24],
    50: [28],
    51: [-1],
    52: [51, 24, 53],
    53: [51, 24, 53],
    54: [28],
    55: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    56: [24, 51, 53, -1],
    57: [35],
    58: [51, 24, 53],
    59: [21, 1, 24, 51, 53, 25, 52, 35, 11, 15, -1, 45],
    60: [0],
    61: [45],
    62: [51, 24, 53],
    63: [52],
    64: [25],
    65: [1],
    66: [21],
    67: [35],
    68: [11],
    69: [15],
    70: [57],
    71: [-1],
    72: [20],
    73: [-1],
    74: [45],
    75: [24, -1],
    76: [20],
    77: [57],
    78: [11],
    79: [15],
    80: [52],
    81: [25],
    82: [1],
    83: [24],
    84: [24],
    85: [47],
    86: [4],
    87: [26],
    88: [27],
    89: [46],
    90: [20, 4, 6, 27, 26, 47, -1, 46, 64],
    91: [6],
    92: [24, -1],
    93: [20],
    94: [24, 51, 53, -1],
    95: [51],
    96: [51],
    97: [51],
    98: [51],
    99: [24],
    100: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    101: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    102: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    103: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    104: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    105: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    106: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    107: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    108: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    109: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    110: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    111: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    112: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    113: [42],
    114: [41],
    115: [59],
    116: [20, 22, 4, 24, 6, 54, 25, 26, 27, -1, 59, 41, 42, 32, 47],
    117: [24],
    118: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    119: [20, 22, 4, 24, 6, 54, 25, 26, 27, 59, 41, 42, 32, 47],
    120: [24, -1],
    121: [32],
    122: [6],
    123: [20, 22, 4, 24, 6, 54, 25, 26, 27, -1, 59, 41, 42, 32, 47],
    124: [20],
    125: [22],
    126: [25],
    127: [47],
    128: [24],
    129: [4],
    130: [26],
    131: [27],
}
nonterminal_rules = {
    65: [
        "$_gen9 = list($expression_placeholder_kv)",
    ],
    66: [
        "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    ],
    67: [
        "$_gen7 = list($task_sections)",
    ],
    68: [
        "$inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )",
    ],
    69: [
        "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
        "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
        "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
        "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
        "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
        "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
        "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
        "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
        "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
        "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
        "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
        "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
        "$e = :not $e -> LogicalNot( expression=$1 )",
        "$e = :plus $e -> UnaryPlus( expression=$1 )",
        "$e = :dash $e -> UnaryNegation( expression=$1 )",
        "$e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )",
        "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
        "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
        "$e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )",
        "$e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )",
        "$e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )",
        "$e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )",
        "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
        "$e = $string_literal",
        "$e = :identifier",
        "$e = :boolean",
        "$e = :integer",
        "$e = :float",
    ],
    70: [
        "$meta_map = :lbrace $_gen12 :rbrace -> $1",
    ],
    71: [
        "$_gen21 = list($type_e, :comma)",
    ],
    72: [
        "$_gen17 = $call_body",
        "$_gen17 = :_empty",
    ],
    73: [
        "$_gen23 = list($object_kv, :comma)",
    ],
    74: [
        "$_gen6 = list($import_alias)",
    ],
    75: [
        "$_gen8 = list($command_part)",
    ],
    76: [
        "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    ],
    77: [
        "$_gen13 = $setter",
        "$_gen13 = :_empty",
    ],
    78: [
        "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    ],
    79: [
        "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    80: [
        "$outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )",
    ],
    81: [
        "$meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    82: [
        "$input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    ],
    83: [
        "$file_body_element = $workflow",
        "$file_body_element = $task",
        "$file_body_element = $struct",
    ],
    84: [
        "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    ],
    85: [
        "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    ],
    86: [
        "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    ],
    87: [
        "$command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )",
    ],
    88: [
        "$string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )",
    ],
    89: [
        "$_gen16 = $alias",
        "$_gen16 = :_empty",
    ],
    90: [
        "$_gen18 = list($input_kv, :comma)",
    ],
    91: [
        "$_gen20 = list($meta_kv, :comma)",
    ],
    92: [
        "$_gen22 = list($e, :comma)",
    ],
    93: [
        "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    ],
    94: [
        "$task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )",
    ],
    95: [
        "$_gen2 = list($struct_declaration)",
    ],
    96: [
        "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    ],
    97: [
        "$_gen5 = $import_namespace",
        "$_gen5 = :_empty",
    ],
    98: [
        "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    ],
    99: [
        "$_gen10 = list($input_declaration)",
    ],
    100: [
        "$command_part = :cmd_part",
        "$command_part = $expression_placeholder",
    ],
    101: [
        "$setter = :equal $e -> $1",
    ],
    102: [
        "$_gen14 = list($output_kv)",
    ],
    103: [
        "$wf_body_element = $call",
        "$wf_body_element = $declaration",
        "$wf_body_element = $while_loop",
        "$wf_body_element = $if_stmt",
        "$wf_body_element = $scatter",
        "$wf_body_element = $inputs",
        "$wf_body_element = $outputs",
        "$wf_body_element = $wf_parameter_meta",
        "$wf_body_element = $wf_meta",
    ],
    104: [
        "$_gen0 = list($import)",
    ],
    105: [
        "$alias = :as :identifier -> $1",
    ],
    106: [
        "$expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    ],
    107: [
        "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    ],
    108: [
        "$_gen3 = :string",
        "$_gen3 = :_empty",
    ],
    109: [
        "$type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )",
        "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
        "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
        "$type_e = :type",
        "$type_e = :identifier",
    ],
    110: [
        "$string_piece = :string",
        "$string_piece = $expression_placeholder",
    ],
    111: [
        "$_gen15 = list($wf_body_element)",
    ],
    112: [
        "$meta_value = $static_string",
        "$meta_value = :boolean",
        "$meta_value = :integer",
        "$meta_value = :float",
        "$meta_value = :null",
        "$meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )",
        "$meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )",
    ],
    113: [
        "$_gen19 = list($meta_value, :comma)",
    ],
    114: [
        "$call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )",
    ],
    115: [
        "$task_sections = $command",
        "$task_sections = $inputs",
        "$task_sections = $outputs",
        "$task_sections = $runtime",
        "$task_sections = $parameter_meta",
        "$task_sections = $meta",
        "$task_sections = $declaration",
    ],
    116: [
        "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    ],
    117: [
        "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    ],
    118: [
        "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    ],
    119: [
        "$import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    ],
    120: [
        "$if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )",
    ],
    121: [
        "$_gen11 = list($kv)",
    ],
    122: [
        "$rt_map = :lbrace $_gen11 :rbrace -> $1",
    ],
    123: [
        "$while_loop = :while :lparen $e :rparen :lbrace $_gen15 :rbrace -> WhileLoop( expression=$2, body=$5 )",
    ],
    124: [
        "$call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )",
    ],
    125: [
        "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    ],
    126: [
        "$import_namespace = :as :identifier -> $1",
    ],
    127: [
        "$workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )",
    ],
    128: [
        "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    ],
    129: [
        "$_gen1 = list($file_body_element)",
    ],
    130: [
        "$_gen24 = list($map_kv, :comma)",
    ],
    131: [
        "$static_string = :quote $_gen3 :quote -> StaticString( value=$1 )",
    ],
    132: [
        "$_gen12 = list($meta_kv)",
    ],
    133: [
        "$_gen4 = list($string_piece)",
    ],
    134: [
        "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    ],
    135: [
        "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    ],
}
rules = {
    0: "$_gen0 = list($import)",
    1: "$_gen1 = list($file_body_element)",
    2: "$document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )",
    3: "$file_body_element = $workflow",
    4: "$file_body_element = $task",
    5: "$file_body_element = $struct",
    6: "$version = :version :version_name -> VersionDeclaration( v=$1 )",
    7: "$_gen2 = list($struct_declaration)",
    8: "$struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )",
    9: "$struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )",
    10: "$_gen3 = :string",
    11: "$_gen3 = :_empty",
    12: "$static_string = :quote $_gen3 :quote -> StaticString( value=$1 )",
    13: "$_gen4 = list($string_piece)",
    14: "$string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )",
    15: "$string_piece = :string",
    16: "$string_piece = $expression_placeholder",
    17: "$_gen5 = $import_namespace",
    18: "$_gen5 = :_empty",
    19: "$_gen6 = list($import_alias)",
    20: "$import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )",
    21: "$import_namespace = :as :identifier -> $1",
    22: "$import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )",
    23: "$_gen7 = list($task_sections)",
    24: "$task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )",
    25: "$task_sections = $command",
    26: "$task_sections = $inputs",
    27: "$task_sections = $outputs",
    28: "$task_sections = $runtime",
    29: "$task_sections = $parameter_meta",
    30: "$task_sections = $meta",
    31: "$task_sections = $declaration",
    32: "$_gen8 = list($command_part)",
    33: "$command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )",
    34: "$command_part = :cmd_part",
    35: "$command_part = $expression_placeholder",
    36: "$_gen9 = list($expression_placeholder_kv)",
    37: "$expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )",
    38: "$expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )",
    39: "$_gen10 = list($input_declaration)",
    40: "$inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )",
    41: "$runtime = :runtime $rt_map -> Runtime( map=$1 )",
    42: "$_gen11 = list($kv)",
    43: "$rt_map = :lbrace $_gen11 :rbrace -> $1",
    44: "$kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )",
    45: "$meta = :meta $meta_map -> Meta( map=$1 )",
    46: "$parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    47: "$_gen12 = list($meta_kv)",
    48: "$meta_map = :lbrace $_gen12 :rbrace -> $1",
    49: "$meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )",
    50: "$_gen13 = $setter",
    51: "$_gen13 = :_empty",
    52: "$input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )",
    53: "$declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )",
    54: "$setter = :equal $e -> $1",
    55: "$map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )",
    56: "$_gen14 = list($output_kv)",
    57: "$outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )",
    58: "$output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )",
    59: "$_gen15 = list($wf_body_element)",
    60: "$workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )",
    61: "$wf_body_element = $call",
    62: "$wf_body_element = $declaration",
    63: "$wf_body_element = $while_loop",
    64: "$wf_body_element = $if_stmt",
    65: "$wf_body_element = $scatter",
    66: "$wf_body_element = $inputs",
    67: "$wf_body_element = $outputs",
    68: "$wf_body_element = $wf_parameter_meta",
    69: "$wf_body_element = $wf_meta",
    70: "$_gen16 = $alias",
    71: "$_gen16 = :_empty",
    72: "$_gen17 = $call_body",
    73: "$_gen17 = :_empty",
    74: "$call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )",
    75: "$_gen18 = list($input_kv, :comma)",
    76: "$call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )",
    77: "$alias = :as :identifier -> $1",
    78: "$wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )",
    79: "$wf_meta = :meta $meta_map -> Meta( map=$1 )",
    80: "$while_loop = :while :lparen $e :rparen :lbrace $_gen15 :rbrace -> WhileLoop( expression=$2, body=$5 )",
    81: "$if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )",
    82: "$scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )",
    83: "$object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )",
    84: "$input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )",
    85: "$meta_value = $static_string",
    86: "$meta_value = :boolean",
    87: "$meta_value = :integer",
    88: "$meta_value = :float",
    89: "$meta_value = :null",
    90: "$_gen19 = list($meta_value, :comma)",
    91: "$meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )",
    92: "$_gen20 = list($meta_kv, :comma)",
    93: "$meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )",
    94: "$_gen21 = list($type_e, :comma)",
    95: "$type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )",
    96: "$type_e = :type <=> :qmark -> OptionalType( innerType=$0 )",
    97: "$type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )",
    98: "$type_e = :type",
    99: "$type_e = :identifier",
    100: "$e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )",
    101: "$e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )",
    102: "$e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )",
    103: "$e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )",
    104: "$e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )",
    105: "$e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )",
    106: "$e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )",
    107: "$e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )",
    108: "$e = $e :plus $e -> Add( lhs=$0, rhs=$2 )",
    109: "$e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )",
    110: "$e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )",
    111: "$e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )",
    112: "$e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )",
    113: "$e = :not $e -> LogicalNot( expression=$1 )",
    114: "$e = :plus $e -> UnaryPlus( expression=$1 )",
    115: "$e = :dash $e -> UnaryNegation( expression=$1 )",
    116: "$_gen22 = list($e, :comma)",
    117: "$e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )",
    118: "$e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )",
    119: "$e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )",
    120: "$_gen23 = list($object_kv, :comma)",
    121: "$e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )",
    122: "$e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )",
    123: "$_gen24 = list($map_kv, :comma)",
    124: "$e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )",
    125: "$e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )",
    126: "$e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )",
    127: "$e = $string_literal",
    128: "$e = :identifier",
    129: "$e = :boolean",
    130: "$e = :integer",
    131: "$e = :float",
}
def is_terminal(id): return isinstance(id, int) and 0 <= id <= 64
def parse(tokens, errors=None, start=None):
    if errors is None:
        errors = DefaultSyntaxErrorHandler()
    if isinstance(tokens, str):
        tokens = lex(tokens, 'string', errors)
    ctx = ParserContext(tokens, errors)
    tree = parse_document(ctx)
    if tokens.current() != None:
        raise ctx.errors.excess_tokens()
    return tree
def expect(ctx, terminal_id):
    current = ctx.tokens.current()
    if not current:
        raise ctx.errors.no_more_tokens(ctx.nonterminal, terminals[terminal_id], ctx.tokens.last())
    if current.id != terminal_id:
        raise ctx.errors.unexpected_symbol(ctx.nonterminal, current, [terminals[terminal_id]], ctx.rule)
    next = ctx.tokens.advance()
    if next and not is_terminal(next.id):
        raise ctx.errors.invalid_terminal(ctx.nonterminal, next)
    return current
# START definitions for expression parser: e
infix_binding_power_e = {
    14: 4000, # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
    5: 5000, # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
    13: 6000, # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
    29: 6000, # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
    23: 7000, # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
    36: 7000, # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
    38: 7000, # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
    16: 7000, # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
    41: 8000, # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
    59: 8000, # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
    56: 9000, # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
    31: 9000, # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
    63: 9000, # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
    22: 11000, # $e = :identifier <=> :lparen list($e, :comma) :rparen -> FunctionCall( name=$0, params=$2 )
    6: 12000, # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
    48: 13000, # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
}
prefix_binding_power_e = {
    42: 10000, # $e = :not $e -> LogicalNot( expression=$1 )
    41: 10000, # $e = :plus $e -> UnaryPlus( expression=$1 )
    59: 10000, # $e = :dash $e -> UnaryNegation( expression=$1 )
}
def get_infix_binding_power_e(terminal_id):
    try:
        return infix_binding_power_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_e(terminal_id):
    try:
        return prefix_binding_power_e[terminal_id]
    except:
        return 0
def parse_e(ctx):
    return parse_e_internal(ctx, rbp=0)
def parse_e_internal(ctx, rbp=0):
    left = nud_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_e(ctx.tokens.current().id):
        left = led_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_e(ctx):
    tree = ParseTree(NonTerminal(69, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if not current:
        return tree
    elif current.id in rule_first[113]:
        # rule first == not
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :not $e -> LogicalNot( expression=$1 )
        ctx.rule = rules[113]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalNot', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 42))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(42)))
        tree.isPrefix = True
    elif current.id in rule_first[114]:
        # rule first == plus
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :plus $e -> UnaryPlus( expression=$1 )
        ctx.rule = rules[114]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryPlus', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 41))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(41)))
        tree.isPrefix = True
    elif current.id in rule_first[115]:
        # rule first == dash
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :dash $e -> UnaryNegation( expression=$1 )
        ctx.rule = rules[115]
        ast_parameters = OrderedDict([
            ('expression', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('UnaryNegation', ast_parameters)
        tree.nudMorphemeCount = 2
        tree.add(expect(ctx, 59))
        tree.add(parse_e_internal(ctx, get_prefix_binding_power_e(59)))
        tree.isPrefix = True
    elif current.id in rule_first[117]:
        # rule first == identifier
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[117]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 24))
    elif current.id in rule_first[121]:
        # rule first == object
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :object :lbrace $_gen23 :rbrace -> ObjectLiteral( map=$2 )
        ctx.rule = rules[121]
        ast_parameters = OrderedDict([
            ('map', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectLiteral', ast_parameters)
        tree.nudMorphemeCount = 4
        tree.add(expect(ctx, 32))
        tree.add(expect(ctx, 20))
        tree.add(parse__gen23(ctx))
        tree.add(expect(ctx, 7))
    elif current.id in rule_first[122]:
        # rule first == lsquare
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :lsquare $_gen22 :rsquare -> ArrayLiteral( values=$1 )
        ctx.rule = rules[122]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 6))
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 49))
    elif current.id in rule_first[124]:
        # rule first == lbrace
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :lbrace $_gen24 :rbrace -> MapLiteral( map=$1 )
        ctx.rule = rules[124]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 20))
        tree.add(parse__gen24(ctx))
        tree.add(expect(ctx, 7))
    elif current.id in rule_first[125]:
        # rule first == lparen
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :lparen $_gen22 :rparen -> TupleLiteral( values=$1 )
        ctx.rule = rules[125]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('TupleLiteral', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 22))
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 39))
    elif current.id in rule_first[126]:
        # rule first == if
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :if $e :then $e :else $e -> TernaryIf( cond=$1, iftrue=$3, iffalse=$5 )
        ctx.rule = rules[126]
        ast_parameters = OrderedDict([
            ('cond', 1),
            ('iftrue', 3),
            ('iffalse', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('TernaryIf', ast_parameters)
        tree.nudMorphemeCount = 6
        tree.add(expect(ctx, 25))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 43))
        tree.add(parse_e(ctx))
        tree.add(expect(ctx, 40))
        tree.add(parse_e(ctx))
    elif current.id in rule_first[127]:
        # rule first == quote
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = $string_literal
        ctx.rule = rules[127]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_string_literal(ctx))
    elif current.id in rule_first[128]:
        # rule first == identifier
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :identifier
        ctx.rule = rules[128]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 24))
    elif current.id in rule_first[129]:
        # rule first == boolean
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :boolean
        ctx.rule = rules[129]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 4))
    elif current.id in rule_first[130]:
        # rule first == integer
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :integer
        ctx.rule = rules[130]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 26))
    elif current.id in rule_first[131]:
        # rule first == float
        # e first == lbrace, lparen, boolean, identifier, lsquare, e, if, integer, float, dash, plus, not, object, quote
        # $e = :float
        ctx.rule = rules[131]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 27))
    return tree
def led_e(left, ctx):
    tree = ParseTree(NonTerminal(69, 'e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "e"
    if current.id == 14: # :double_pipe
        # $e = $e :double_pipe $e -> LogicalOr( lhs=$0, rhs=$2 )
        ctx.rule = rules[100]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalOr', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 14)) # :double_pipe
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(14) - modifier))
    if current.id == 5: # :double_ampersand
        # $e = $e :double_ampersand $e -> LogicalAnd( lhs=$0, rhs=$2 )
        ctx.rule = rules[101]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LogicalAnd', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 5)) # :double_ampersand
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(5) - modifier))
    if current.id == 13: # :double_equal
        # $e = $e :double_equal $e -> Equals( lhs=$0, rhs=$2 )
        ctx.rule = rules[102]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Equals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 13)) # :double_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(13) - modifier))
    if current.id == 29: # :not_equal
        # $e = $e :not_equal $e -> NotEquals( lhs=$0, rhs=$2 )
        ctx.rule = rules[103]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('NotEquals', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 29)) # :not_equal
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(29) - modifier))
    if current.id == 23: # :lt
        # $e = $e :lt $e -> LessThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[104]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 23)) # :lt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(23) - modifier))
    if current.id == 36: # :lteq
        # $e = $e :lteq $e -> LessThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[105]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('LessThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 36)) # :lteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(36) - modifier))
    if current.id == 38: # :gt
        # $e = $e :gt $e -> GreaterThan( lhs=$0, rhs=$2 )
        ctx.rule = rules[106]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThan', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 38)) # :gt
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(38) - modifier))
    if current.id == 16: # :gteq
        # $e = $e :gteq $e -> GreaterThanOrEqual( lhs=$0, rhs=$2 )
        ctx.rule = rules[107]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('GreaterThanOrEqual', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 16)) # :gteq
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(16) - modifier))
    if current.id == 41: # :plus
        # $e = $e :plus $e -> Add( lhs=$0, rhs=$2 )
        ctx.rule = rules[108]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Add', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 41)) # :plus
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(41) - modifier))
    if current.id == 59: # :dash
        # $e = $e :dash $e -> Subtract( lhs=$0, rhs=$2 )
        ctx.rule = rules[109]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Subtract', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 59)) # :dash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(59) - modifier))
    if current.id == 56: # :asterisk
        # $e = $e :asterisk $e -> Multiply( lhs=$0, rhs=$2 )
        ctx.rule = rules[110]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Multiply', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 56)) # :asterisk
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(56) - modifier))
    if current.id == 31: # :slash
        # $e = $e :slash $e -> Divide( lhs=$0, rhs=$2 )
        ctx.rule = rules[111]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Divide', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 31)) # :slash
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(31) - modifier))
    if current.id == 63: # :percent
        # $e = $e :percent $e -> Remainder( lhs=$0, rhs=$2 )
        ctx.rule = rules[112]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Remainder', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 63)) # :percent
        modifier = 0
        tree.isInfix = True
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(63) - modifier))
    if current.id == 22: # :lparen
        # $e = :identifier <=> :lparen $_gen22 :rparen -> FunctionCall( name=$0, params=$2 )
        ctx.rule = rules[117]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('params', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('FunctionCall', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 22)) # :lparen
        tree.add(parse__gen22(ctx))
        tree.add(expect(ctx, 39)) # :rparen
    if current.id == 6: # :lsquare
        # $e = $e <=> :lsquare $e :rsquare -> ArrayOrMapLookup( lhs=$0, rhs=$2 )
        ctx.rule = rules[118]
        ast_parameters = OrderedDict([
            ('lhs', 0),
            ('rhs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ArrayOrMapLookup', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 6)) # :lsquare
        modifier = 0
        tree.add(parse_e_internal(ctx, get_infix_binding_power_e(6) - modifier))
        tree.add(expect(ctx, 49)) # :rsquare
    if current.id == 48: # :dot
        # $e = $e <=> :dot :identifier -> MemberAccess( value=$0, member=$2 )
        ctx.rule = rules[119]
        ast_parameters = OrderedDict([
            ('value', 0),
            ('member', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MemberAccess', ast_parameters)
        tree.isExprNud = True
        tree.add(left)
        tree.add(expect(ctx, 48)) # :dot
        tree.add(expect(ctx, 24)) # :identifier
    return tree
# END definitions for expression parser: e
# START definitions for expression parser: meta_value
infix_binding_power_meta_value = {
}
prefix_binding_power_meta_value = {
}
def get_infix_binding_power_meta_value(terminal_id):
    try:
        return infix_binding_power_meta_value[terminal_id]
    except:
        return 0
def get_prefix_binding_power_meta_value(terminal_id):
    try:
        return prefix_binding_power_meta_value[terminal_id]
    except:
        return 0
def parse_meta_value(ctx):
    return parse_meta_value_internal(ctx, rbp=0)
def parse_meta_value_internal(ctx, rbp=0):
    left = nud_meta_value(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_meta_value(ctx.tokens.current().id):
        left = led_meta_value(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_meta_value(ctx):
    tree = ParseTree(NonTerminal(112, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    if not current:
        return tree
    if current.id in rule_first[85]:
        # rule first == quote
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = $static_string
        ctx.rule = rules[85]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(parse_static_string(ctx))
    elif current.id in rule_first[86]:
        # rule first == boolean
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :boolean
        ctx.rule = rules[86]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 4))
    elif current.id in rule_first[87]:
        # rule first == integer
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :integer
        ctx.rule = rules[87]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 26))
    elif current.id in rule_first[88]:
        # rule first == float
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :float
        ctx.rule = rules[88]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 27))
    elif current.id in rule_first[89]:
        # rule first == null
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :null
        ctx.rule = rules[89]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 46))
    elif current.id in rule_first[91]:
        # rule first == lsquare
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :lsquare $_gen19 :rsquare -> MetaArray( values=$1 )
        ctx.rule = rules[91]
        ast_parameters = OrderedDict([
            ('values', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaArray', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 6))
        tree.add(parse__gen19(ctx))
        tree.add(expect(ctx, 49))
    elif current.id in rule_first[93]:
        # rule first == lbrace
        # e first == float, meta_value, lbrace, null, boolean, lsquare, integer, quote
        # $meta_value = :lbrace $_gen20 :rbrace -> MetaObject( map=$1 )
        ctx.rule = rules[93]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaObject', ast_parameters)
        tree.nudMorphemeCount = 3
        tree.add(expect(ctx, 20))
        tree.add(parse__gen20(ctx))
        tree.add(expect(ctx, 7))
    return tree
def led_meta_value(left, ctx):
    tree = ParseTree(NonTerminal(112, 'meta_value'))
    current = ctx.tokens.current()
    ctx.nonterminal = "meta_value"
    return tree
# END definitions for expression parser: meta_value
# START definitions for expression parser: type_e
infix_binding_power_type_e = {
    6: 1000, # $type_e = :type <=> :lsquare list($type_e, :comma) :rsquare -> Type( name=$0, subtype=$2 )
    58: 2000, # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
    41: 3000, # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
}
prefix_binding_power_type_e = {
}
def get_infix_binding_power_type_e(terminal_id):
    try:
        return infix_binding_power_type_e[terminal_id]
    except:
        return 0
def get_prefix_binding_power_type_e(terminal_id):
    try:
        return prefix_binding_power_type_e[terminal_id]
    except:
        return 0
def parse_type_e(ctx):
    return parse_type_e_internal(ctx, rbp=0)
def parse_type_e_internal(ctx, rbp=0):
    left = nud_type_e(ctx)
    if isinstance(left, ParseTree):
        left.isExpr = True
        left.isNud = True
    while ctx.tokens.current() and rbp < get_infix_binding_power_type_e(ctx.tokens.current().id):
        left = led_type_e(left, ctx)
    if left:
        left.isExpr = True
    return left
def nud_type_e(ctx):
    tree = ParseTree(NonTerminal(109, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if not current:
        return tree
    if current.id in rule_first[95]:
        # rule first == type
        # e first == identifier, type, type_e
        # $type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[95]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 51))
    elif current.id in rule_first[96]:
        # rule first == type
        # e first == identifier, type, type_e
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[96]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 51))
    elif current.id in rule_first[97]:
        # rule first == type
        # e first == identifier, type, type_e
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[97]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 51))
    elif current.id in rule_first[98]:
        # rule first == type
        # e first == identifier, type, type_e
        # $type_e = :type
        ctx.rule = rules[98]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 51))
    elif current.id in rule_first[99]:
        # rule first == identifier
        # e first == identifier, type, type_e
        # $type_e = :identifier
        ctx.rule = rules[99]
        tree.astTransform = AstTransformSubstitution(0)
        tree.nudMorphemeCount = 1
        tree.add(expect(ctx, 24))
    return tree
def led_type_e(left, ctx):
    tree = ParseTree(NonTerminal(109, 'type_e'))
    current = ctx.tokens.current()
    ctx.nonterminal = "type_e"
    if current.id == 6: # :lsquare
        # $type_e = :type <=> :lsquare $_gen21 :rsquare -> Type( name=$0, subtype=$2 )
        ctx.rule = rules[95]
        ast_parameters = OrderedDict([
            ('name', 0),
            ('subtype', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Type', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 6)) # :lsquare
        tree.add(parse__gen21(ctx))
        tree.add(expect(ctx, 49)) # :rsquare
    if current.id == 58: # :qmark
        # $type_e = :type <=> :qmark -> OptionalType( innerType=$0 )
        ctx.rule = rules[96]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('OptionalType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 58)) # :qmark
    if current.id == 41: # :plus
        # $type_e = :type <=> :plus -> NonEmptyType( innerType=$0 )
        ctx.rule = rules[97]
        ast_parameters = OrderedDict([
            ('innerType', 0),
        ])
        tree.astTransform = AstTransformNodeCreator('NonEmptyType', ast_parameters)
        tree.add(left)
        tree.add(expect(ctx, 41)) # :plus
    return tree
# END definitions for expression parser: type_e
def parse__gen0(ctx):
    tree = ParseTree(NonTerminal(104, '_gen0'))
    tree.list = True
    ctx.nonterminal = "_gen0"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[104] and \
       ctx.tokens.current().id in nonterminal_follow[104]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(104)):
        tree.add(parse_import(ctx))
        ctx.nonterminal = "_gen0" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen1(ctx):
    tree = ParseTree(NonTerminal(129, '_gen1'))
    tree.list = True
    ctx.nonterminal = "_gen1"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[129] and \
       ctx.tokens.current().id in nonterminal_follow[129]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(129)):
        tree.add(parse_file_body_element(ctx))
        ctx.nonterminal = "_gen1" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen10(ctx):
    tree = ParseTree(NonTerminal(99, '_gen10'))
    tree.list = True
    ctx.nonterminal = "_gen10"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[99] and \
       ctx.tokens.current().id in nonterminal_follow[99]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(99)):
        tree.add(parse_input_declaration(ctx))
        ctx.nonterminal = "_gen10" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen11(ctx):
    tree = ParseTree(NonTerminal(121, '_gen11'))
    tree.list = True
    ctx.nonterminal = "_gen11"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[121] and \
       ctx.tokens.current().id in nonterminal_follow[121]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(121)):
        tree.add(parse_kv(ctx))
        ctx.nonterminal = "_gen11" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen12(ctx):
    tree = ParseTree(NonTerminal(132, '_gen12'))
    tree.list = True
    ctx.nonterminal = "_gen12"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[132] and \
       ctx.tokens.current().id in nonterminal_follow[132]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(132)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen12" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen14(ctx):
    tree = ParseTree(NonTerminal(102, '_gen14'))
    tree.list = True
    ctx.nonterminal = "_gen14"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[102] and \
       ctx.tokens.current().id in nonterminal_follow[102]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(102)):
        tree.add(parse_output_kv(ctx))
        ctx.nonterminal = "_gen14" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen15(ctx):
    tree = ParseTree(NonTerminal(111, '_gen15'))
    tree.list = True
    ctx.nonterminal = "_gen15"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[111] and \
       ctx.tokens.current().id in nonterminal_follow[111]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(111)):
        tree.add(parse_wf_body_element(ctx))
        ctx.nonterminal = "_gen15" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen18(ctx):
    tree = ParseTree(NonTerminal(90, '_gen18'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen18"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[90] and \
       ctx.tokens.current().id in nonterminal_follow[90]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(90)):
        tree.add(parse_input_kv(ctx))
        ctx.nonterminal = "_gen18" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen19(ctx):
    tree = ParseTree(NonTerminal(113, '_gen19'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen19"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[113] and \
       ctx.tokens.current().id in nonterminal_follow[113]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(113)):
        tree.add(parse_meta_value(ctx))
        ctx.nonterminal = "_gen19" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen2(ctx):
    tree = ParseTree(NonTerminal(95, '_gen2'))
    tree.list = True
    ctx.nonterminal = "_gen2"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[95] and \
       ctx.tokens.current().id in nonterminal_follow[95]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(95)):
        tree.add(parse_struct_declaration(ctx))
        ctx.nonterminal = "_gen2" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen20(ctx):
    tree = ParseTree(NonTerminal(91, '_gen20'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen20"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[91] and \
       ctx.tokens.current().id in nonterminal_follow[91]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(91)):
        tree.add(parse_meta_kv(ctx))
        ctx.nonterminal = "_gen20" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen21(ctx):
    tree = ParseTree(NonTerminal(71, '_gen21'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen21"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[71] and \
       ctx.tokens.current().id in nonterminal_follow[71]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(71)):
        tree.add(parse_type_e(ctx))
        ctx.nonterminal = "_gen21" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen22(ctx):
    tree = ParseTree(NonTerminal(92, '_gen22'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen22"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[92] and \
       ctx.tokens.current().id in nonterminal_follow[92]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(92)):
        tree.add(parse_e(ctx))
        ctx.nonterminal = "_gen22" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen23(ctx):
    tree = ParseTree(NonTerminal(73, '_gen23'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen23"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[73] and \
       ctx.tokens.current().id in nonterminal_follow[73]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(73)):
        tree.add(parse_object_kv(ctx))
        ctx.nonterminal = "_gen23" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen24(ctx):
    tree = ParseTree(NonTerminal(130, '_gen24'))
    tree.list = True
    tree.list_separator_id = 2
    ctx.nonterminal = "_gen24"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[130] and \
       ctx.tokens.current().id in nonterminal_follow[130]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(130)):
        tree.add(parse_map_kv(ctx))
        ctx.nonterminal = "_gen24" # Horrible -- because parse_* can reset this
        if ctx.tokens.current() is not None and ctx.tokens.current().id == 2:
            tree.add(expect(ctx, 2));
        else:
          break
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen4(ctx):
    tree = ParseTree(NonTerminal(133, '_gen4'))
    tree.list = True
    ctx.nonterminal = "_gen4"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[133] and \
       ctx.tokens.current().id in nonterminal_follow[133]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(133)):
        tree.add(parse_string_piece(ctx))
        ctx.nonterminal = "_gen4" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen6(ctx):
    tree = ParseTree(NonTerminal(74, '_gen6'))
    tree.list = True
    ctx.nonterminal = "_gen6"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[74] and \
       ctx.tokens.current().id in nonterminal_follow[74]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(74)):
        tree.add(parse_import_alias(ctx))
        ctx.nonterminal = "_gen6" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen7(ctx):
    tree = ParseTree(NonTerminal(67, '_gen7'))
    tree.list = True
    ctx.nonterminal = "_gen7"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[67] and \
       ctx.tokens.current().id in nonterminal_follow[67]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(67)):
        tree.add(parse_task_sections(ctx))
        ctx.nonterminal = "_gen7" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen8(ctx):
    tree = ParseTree(NonTerminal(75, '_gen8'))
    tree.list = True
    ctx.nonterminal = "_gen8"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[75] and \
       ctx.tokens.current().id in nonterminal_follow[75]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(75)):
        tree.add(parse_command_part(ctx))
        ctx.nonterminal = "_gen8" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen9(ctx):
    tree = ParseTree(NonTerminal(65, '_gen9'))
    tree.list = True
    ctx.nonterminal = "_gen9"
    if ctx.tokens.current() is not None and \
       ctx.tokens.current().id not in nonterminal_first[65] and \
       ctx.tokens.current().id in nonterminal_follow[65]:
        return tree
    if ctx.tokens.current() is None:
        return tree
    minimum = 0
    while minimum > 0 or \
           (ctx.tokens.current() is not None and \
            ctx.tokens.current().id in nonterminal_first.get(65)):
        tree.add(parse_expression_placeholder_kv(ctx))
        ctx.nonterminal = "_gen9" # Horrible -- because parse_* can reset this
        minimum = max(minimum - 1, 0)
    return tree
def parse__gen13(ctx):
    current = ctx.tokens.current()
    rule = table[12][current.id] if current else -1
    tree = ParseTree(NonTerminal(77, '_gen13'))
    ctx.nonterminal = "_gen13"
    if current != None and current.id in nonterminal_follow[77] and current.id not in nonterminal_first[77]:
        return tree
    if current == None:
        return tree
    if rule == 50: # $_gen13 = $setter
        ctx.rule = rules[50]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen16(ctx):
    current = ctx.tokens.current()
    rule = table[24][current.id] if current else -1
    tree = ParseTree(NonTerminal(89, '_gen16'))
    ctx.nonterminal = "_gen16"
    if current != None and current.id in nonterminal_follow[89] and current.id not in nonterminal_first[89]:
        return tree
    if current == None:
        return tree
    if rule == 70: # $_gen16 = $alias
        ctx.rule = rules[70]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_alias(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen17(ctx):
    current = ctx.tokens.current()
    rule = table[7][current.id] if current else -1
    tree = ParseTree(NonTerminal(72, '_gen17'))
    ctx.nonterminal = "_gen17"
    if current != None and current.id in nonterminal_follow[72] and current.id not in nonterminal_first[72]:
        return tree
    if current == None:
        return tree
    if rule == 72: # $_gen17 = $call_body
        ctx.rule = rules[72]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call_body(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse__gen3(ctx):
    current = ctx.tokens.current()
    rule = table[43][current.id] if current else -1
    tree = ParseTree(NonTerminal(108, '_gen3'))
    ctx.nonterminal = "_gen3"
    if current != None and current.id in nonterminal_follow[108] and current.id not in nonterminal_first[108]:
        return tree
    if current == None:
        return tree
    if rule == 10: # $_gen3 = :string
        ctx.rule = rules[10]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 17) # :string
        tree.add(t)
        return tree
    return tree
def parse__gen5(ctx):
    current = ctx.tokens.current()
    rule = table[32][current.id] if current else -1
    tree = ParseTree(NonTerminal(97, '_gen5'))
    ctx.nonterminal = "_gen5"
    if current != None and current.id in nonterminal_follow[97] and current.id not in nonterminal_first[97]:
        return tree
    if current == None:
        return tree
    if rule == 17: # $_gen5 = $import_namespace
        ctx.rule = rules[17]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_import_namespace(ctx)
        tree.add(subtree)
        return tree
    return tree
def parse_alias(ctx):
    current = ctx.tokens.current()
    rule = table[40][current.id] if current else -1
    tree = ParseTree(NonTerminal(105, 'alias'))
    ctx.nonterminal = "alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 77: # $alias = :as :identifier -> $1
        ctx.rule = rules[77]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 57) # :as
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[105] if x >=0],
      rules[77]
    )
def parse_call(ctx):
    current = ctx.tokens.current()
    rule = table[49][current.id] if current else -1
    tree = ParseTree(NonTerminal(114, 'call'))
    ctx.nonterminal = "call"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 74: # $call = :call :fqn $_gen16 $_gen17 -> Call( task=$1, alias=$2, body=$3 )
        ctx.rule = rules[74]
        ast_parameters = OrderedDict([
            ('task', 1),
            ('alias', 2),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Call', ast_parameters)
        t = expect(ctx, 45) # :call
        tree.add(t)
        t = expect(ctx, 33) # :fqn
        tree.add(t)
        subtree = parse__gen16(ctx)
        tree.add(subtree)
        subtree = parse__gen17(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[114] if x >=0],
      rules[74]
    )
def parse_call_body(ctx):
    current = ctx.tokens.current()
    rule = table[59][current.id] if current else -1
    tree = ParseTree(NonTerminal(124, 'call_body'))
    ctx.nonterminal = "call_body"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 76: # $call_body = :lbrace :input :colon $_gen18 :rbrace -> CallBody( inputs=$3 )
        ctx.rule = rules[76]
        ast_parameters = OrderedDict([
            ('inputs', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('CallBody', ast_parameters)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        t = expect(ctx, 21) # :input
        tree.add(t)
        t = expect(ctx, 50) # :colon
        tree.add(t)
        subtree = parse__gen18(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[124] if x >=0],
      rules[76]
    )
def parse_command(ctx):
    current = ctx.tokens.current()
    rule = table[22][current.id] if current else -1
    tree = ParseTree(NonTerminal(87, 'command'))
    ctx.nonterminal = "command"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 33: # $command = :raw_command :raw_cmd_start $_gen8 :raw_cmd_end -> RawCommand( parts=$2 )
        ctx.rule = rules[33]
        ast_parameters = OrderedDict([
            ('parts', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RawCommand', ast_parameters)
        t = expect(ctx, 60) # :raw_command
        tree.add(t)
        t = expect(ctx, 12) # :raw_cmd_start
        tree.add(t)
        subtree = parse__gen8(ctx)
        tree.add(subtree)
        t = expect(ctx, 10) # :raw_cmd_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[87] if x >=0],
      rules[33]
    )
def parse_command_part(ctx):
    current = ctx.tokens.current()
    rule = table[35][current.id] if current else -1
    tree = ParseTree(NonTerminal(100, 'command_part'))
    ctx.nonterminal = "command_part"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 34: # $command_part = :cmd_part
        ctx.rule = rules[34]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 8) # :cmd_part
        tree.add(t)
        return tree
    elif rule == 35: # $command_part = $expression_placeholder
        ctx.rule = rules[35]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[100] if x >=0],
      rules[35]
    )
def parse_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[70][current.id] if current else -1
    tree = ParseTree(NonTerminal(135, 'declaration'))
    ctx.nonterminal = "declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 53: # $declaration = $type_e :identifier $setter -> Declaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[53]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Declaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        subtree = parse_setter(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[135] if x >=0],
      rules[53]
    )
def parse_document(ctx):
    current = ctx.tokens.current()
    rule = table[31][current.id] if current else -1
    tree = ParseTree(NonTerminal(96, 'document'))
    ctx.nonterminal = "document"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 2: # $document = $version $_gen0 $_gen1 -> Draft3File( version=$0, imports=$1, body=$2 )
        ctx.rule = rules[2]
        ast_parameters = OrderedDict([
            ('version', 0),
            ('imports', 1),
            ('body', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Draft3File', ast_parameters)
        subtree = parse_version(ctx)
        tree.add(subtree)
        subtree = parse__gen0(ctx)
        tree.add(subtree)
        subtree = parse__gen1(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[96] if x >=0],
      rules[2]
    )
def parse_expression_placeholder(ctx):
    current = ctx.tokens.current()
    rule = table[41][current.id] if current else -1
    tree = ParseTree(NonTerminal(106, 'expression_placeholder'))
    ctx.nonterminal = "expression_placeholder"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 37: # $expression_placeholder = :expression_placeholder_start $_gen9 $e :expression_placeholder_end -> ExpressionPlaceholder( attributes=$1, expr=$2 )
        ctx.rule = rules[37]
        ast_parameters = OrderedDict([
            ('attributes', 1),
            ('expr', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholder', ast_parameters)
        t = expect(ctx, 30) # :expression_placeholder_start
        tree.add(t)
        subtree = parse__gen9(ctx)
        tree.add(subtree)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 55) # :expression_placeholder_end
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[106] if x >=0],
      rules[37]
    )
def parse_expression_placeholder_kv(ctx):
    current = ctx.tokens.current()
    rule = table[69][current.id] if current else -1
    tree = ParseTree(NonTerminal(134, 'expression_placeholder_kv'))
    ctx.nonterminal = "expression_placeholder_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 38: # $expression_placeholder_kv = :cmd_attr_hint :identifier :equal $e -> ExpressionPlaceholderAttr( key=$1, value=$3 )
        ctx.rule = rules[38]
        ast_parameters = OrderedDict([
            ('key', 1),
            ('value', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ExpressionPlaceholderAttr', ast_parameters)
        t = expect(ctx, 19) # :cmd_attr_hint
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 28) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[134] if x >=0],
      rules[38]
    )
def parse_file_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[18][current.id] if current else -1
    tree = ParseTree(NonTerminal(83, 'file_body_element'))
    ctx.nonterminal = "file_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 3: # $file_body_element = $workflow
        ctx.rule = rules[3]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_workflow(ctx)
        tree.add(subtree)
        return tree
    elif rule == 4: # $file_body_element = $task
        ctx.rule = rules[4]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_task(ctx)
        tree.add(subtree)
        return tree
    elif rule == 5: # $file_body_element = $struct
        ctx.rule = rules[5]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_struct(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[83] if x >=0],
      rules[5]
    )
def parse_if_stmt(ctx):
    current = ctx.tokens.current()
    rule = table[55][current.id] if current else -1
    tree = ParseTree(NonTerminal(120, 'if_stmt'))
    ctx.nonterminal = "if_stmt"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 81: # $if_stmt = :if :lparen $e :rparen :lbrace $_gen15 :rbrace -> If( expression=$2, body=$5 )
        ctx.rule = rules[81]
        ast_parameters = OrderedDict([
            ('expression', 2),
            ('body', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('If', ast_parameters)
        t = expect(ctx, 25) # :if
        tree.add(t)
        t = expect(ctx, 22) # :lparen
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 39) # :rparen
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[120] if x >=0],
      rules[81]
    )
def parse_import(ctx):
    current = ctx.tokens.current()
    rule = table[54][current.id] if current else -1
    tree = ParseTree(NonTerminal(119, 'import'))
    ctx.nonterminal = "import"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 20: # $import = :import $static_string $_gen5 $_gen6 -> Import( uri=$1, namespace=$2, aliases=$3 )
        ctx.rule = rules[20]
        ast_parameters = OrderedDict([
            ('uri', 1),
            ('namespace', 2),
            ('aliases', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Import', ast_parameters)
        t = expect(ctx, 37) # :import
        tree.add(t)
        subtree = parse_static_string(ctx)
        tree.add(subtree)
        subtree = parse__gen5(ctx)
        tree.add(subtree)
        subtree = parse__gen6(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[119] if x >=0],
      rules[20]
    )
def parse_import_alias(ctx):
    current = ctx.tokens.current()
    rule = table[53][current.id] if current else -1
    tree = ParseTree(NonTerminal(118, 'import_alias'))
    ctx.nonterminal = "import_alias"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 22: # $import_alias = :alias :identifier :as :identifier -> ImportAlias( old_name=$1, new_name=$3 )
        ctx.rule = rules[22]
        ast_parameters = OrderedDict([
            ('old_name', 1),
            ('new_name', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('ImportAlias', ast_parameters)
        t = expect(ctx, 34) # :alias
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 57) # :as
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[118] if x >=0],
      rules[22]
    )
def parse_import_namespace(ctx):
    current = ctx.tokens.current()
    rule = table[61][current.id] if current else -1
    tree = ParseTree(NonTerminal(126, 'import_namespace'))
    ctx.nonterminal = "import_namespace"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 21: # $import_namespace = :as :identifier -> $1
        ctx.rule = rules[21]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 57) # :as
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[126] if x >=0],
      rules[21]
    )
def parse_input_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[17][current.id] if current else -1
    tree = ParseTree(NonTerminal(82, 'input_declaration'))
    ctx.nonterminal = "input_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 52: # $input_declaration = $type_e :identifier $_gen13 -> InputDeclaration( type=$0, name=$1, expression=$2 )
        ctx.rule = rules[52]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('InputDeclaration', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        subtree = parse__gen13(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[82] if x >=0],
      rules[52]
    )
def parse_input_kv(ctx):
    current = ctx.tokens.current()
    rule = table[51][current.id] if current else -1
    tree = ParseTree(NonTerminal(116, 'input_kv'))
    ctx.nonterminal = "input_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 84: # $input_kv = :identifier :equal $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[84]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 28) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[116] if x >=0],
      rules[84]
    )
def parse_inputs(ctx):
    current = ctx.tokens.current()
    rule = table[3][current.id] if current else -1
    tree = ParseTree(NonTerminal(68, 'inputs'))
    ctx.nonterminal = "inputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 40: # $inputs = :input :lbrace $_gen10 :rbrace -> Inputs( inputs=$2 )
        ctx.rule = rules[40]
        ast_parameters = OrderedDict([
            ('inputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Inputs', ast_parameters)
        t = expect(ctx, 21) # :input
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen10(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[68] if x >=0],
      rules[40]
    )
def parse_kv(ctx):
    current = ctx.tokens.current()
    rule = table[11][current.id] if current else -1
    tree = ParseTree(NonTerminal(76, 'kv'))
    ctx.nonterminal = "kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 44: # $kv = :identifier :colon $e -> RuntimeAttribute( key=$0, value=$2 )
        ctx.rule = rules[44]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('RuntimeAttribute', ast_parameters)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 50) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[76] if x >=0],
      rules[44]
    )
def parse_map_kv(ctx):
    current = ctx.tokens.current()
    rule = table[52][current.id] if current else -1
    tree = ParseTree(NonTerminal(117, 'map_kv'))
    ctx.nonterminal = "map_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 55: # $map_kv = $e :colon $e -> MapLiteralKv( key=$0, value=$2 )
        ctx.rule = rules[55]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MapLiteralKv', ast_parameters)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 50) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[117] if x >=0],
      rules[55]
    )
def parse_meta(ctx):
    current = ctx.tokens.current()
    rule = table[16][current.id] if current else -1
    tree = ParseTree(NonTerminal(81, 'meta'))
    ctx.nonterminal = "meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 45: # $meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[45]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 15) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[81] if x >=0],
      rules[45]
    )
def parse_meta_kv(ctx):
    current = ctx.tokens.current()
    rule = table[63][current.id] if current else -1
    tree = ParseTree(NonTerminal(128, 'meta_kv'))
    ctx.nonterminal = "meta_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 49: # $meta_kv = :identifier :colon $meta_value -> MetaKvPair( key=$0, value=$2 )
        ctx.rule = rules[49]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('MetaKvPair', ast_parameters)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 50) # :colon
        tree.add(t)
        subtree = parse_meta_value(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[128] if x >=0],
      rules[49]
    )
def parse_meta_map(ctx):
    current = ctx.tokens.current()
    rule = table[5][current.id] if current else -1
    tree = ParseTree(NonTerminal(70, 'meta_map'))
    ctx.nonterminal = "meta_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 48: # $meta_map = :lbrace $_gen12 :rbrace -> $1
        ctx.rule = rules[48]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen12(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[70] if x >=0],
      rules[48]
    )
def parse_object_kv(ctx):
    current = ctx.tokens.current()
    rule = table[28][current.id] if current else -1
    tree = ParseTree(NonTerminal(93, 'object_kv'))
    ctx.nonterminal = "object_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 83: # $object_kv = :identifier :colon $e -> ObjectKV( key=$0, value=$2 )
        ctx.rule = rules[83]
        ast_parameters = OrderedDict([
            ('key', 0),
            ('value', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('ObjectKV', ast_parameters)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 50) # :colon
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[93] if x >=0],
      rules[83]
    )
def parse_output_kv(ctx):
    current = ctx.tokens.current()
    rule = table[13][current.id] if current else -1
    tree = ParseTree(NonTerminal(78, 'output_kv'))
    ctx.nonterminal = "output_kv"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 58: # $output_kv = $type_e :identifier :equal $e -> Output( type=$0, name=$1, expression=$3 )
        ctx.rule = rules[58]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
            ('expression', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Output', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 28) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[78] if x >=0],
      rules[58]
    )
def parse_outputs(ctx):
    current = ctx.tokens.current()
    rule = table[15][current.id] if current else -1
    tree = ParseTree(NonTerminal(80, 'outputs'))
    ctx.nonterminal = "outputs"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 57: # $outputs = :output :lbrace $_gen14 :rbrace -> Outputs( outputs=$2 )
        ctx.rule = rules[57]
        ast_parameters = OrderedDict([
            ('outputs', 2),
        ])
        tree.astTransform = AstTransformNodeCreator('Outputs', ast_parameters)
        t = expect(ctx, 35) # :output
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen14(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[80] if x >=0],
      rules[57]
    )
def parse_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[20][current.id] if current else -1
    tree = ParseTree(NonTerminal(85, 'parameter_meta'))
    ctx.nonterminal = "parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 46: # $parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[46]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 11) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[85] if x >=0],
      rules[46]
    )
def parse_rt_map(ctx):
    current = ctx.tokens.current()
    rule = table[57][current.id] if current else -1
    tree = ParseTree(NonTerminal(122, 'rt_map'))
    ctx.nonterminal = "rt_map"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 43: # $rt_map = :lbrace $_gen11 :rbrace -> $1
        ctx.rule = rules[43]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen11(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[122] if x >=0],
      rules[43]
    )
def parse_runtime(ctx):
    current = ctx.tokens.current()
    rule = table[33][current.id] if current else -1
    tree = ParseTree(NonTerminal(98, 'runtime'))
    ctx.nonterminal = "runtime"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 41: # $runtime = :runtime $rt_map -> Runtime( map=$1 )
        ctx.rule = rules[41]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Runtime', ast_parameters)
        t = expect(ctx, 62) # :runtime
        tree.add(t)
        subtree = parse_rt_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[98] if x >=0],
      rules[41]
    )
def parse_scatter(ctx):
    current = ctx.tokens.current()
    rule = table[19][current.id] if current else -1
    tree = ParseTree(NonTerminal(84, 'scatter'))
    ctx.nonterminal = "scatter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 82: # $scatter = :scatter :lparen :identifier :in $e :rparen :lbrace $_gen15 :rbrace -> Scatter( item=$2, collection=$4, body=$7 )
        ctx.rule = rules[82]
        ast_parameters = OrderedDict([
            ('item', 2),
            ('collection', 4),
            ('body', 7),
        ])
        tree.astTransform = AstTransformNodeCreator('Scatter', ast_parameters)
        t = expect(ctx, 1) # :scatter
        tree.add(t)
        t = expect(ctx, 22) # :lparen
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 3) # :in
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 39) # :rparen
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[84] if x >=0],
      rules[82]
    )
def parse_setter(ctx):
    current = ctx.tokens.current()
    rule = table[36][current.id] if current else -1
    tree = ParseTree(NonTerminal(101, 'setter'))
    ctx.nonterminal = "setter"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 54: # $setter = :equal $e -> $1
        ctx.rule = rules[54]
        tree.astTransform = AstTransformSubstitution(1)
        t = expect(ctx, 28) # :equal
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[101] if x >=0],
      rules[54]
    )
def parse_static_string(ctx):
    current = ctx.tokens.current()
    rule = table[66][current.id] if current else -1
    tree = ParseTree(NonTerminal(131, 'static_string'))
    ctx.nonterminal = "static_string"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 12: # $static_string = :quote $_gen3 :quote -> StaticString( value=$1 )
        ctx.rule = rules[12]
        ast_parameters = OrderedDict([
            ('value', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StaticString', ast_parameters)
        t = expect(ctx, 47) # :quote
        tree.add(t)
        subtree = parse__gen3(ctx)
        tree.add(subtree)
        t = expect(ctx, 47) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[131] if x >=0],
      rules[12]
    )
def parse_string_literal(ctx):
    current = ctx.tokens.current()
    rule = table[23][current.id] if current else -1
    tree = ParseTree(NonTerminal(88, 'string_literal'))
    ctx.nonterminal = "string_literal"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 14: # $string_literal = :quote $_gen4 :quote -> StringLiteral( pieces=$1 )
        ctx.rule = rules[14]
        ast_parameters = OrderedDict([
            ('pieces', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StringLiteral', ast_parameters)
        t = expect(ctx, 47) # :quote
        tree.add(t)
        subtree = parse__gen4(ctx)
        tree.add(subtree)
        t = expect(ctx, 47) # :quote
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[88] if x >=0],
      rules[14]
    )
def parse_string_piece(ctx):
    current = ctx.tokens.current()
    rule = table[45][current.id] if current else -1
    tree = ParseTree(NonTerminal(110, 'string_piece'))
    ctx.nonterminal = "string_piece"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 15: # $string_piece = :string
        ctx.rule = rules[15]
        tree.astTransform = AstTransformSubstitution(0)
        t = expect(ctx, 17) # :string
        tree.add(t)
        return tree
    elif rule == 16: # $string_piece = $expression_placeholder
        ctx.rule = rules[16]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_expression_placeholder(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[110] if x >=0],
      rules[16]
    )
def parse_struct(ctx):
    current = ctx.tokens.current()
    rule = table[1][current.id] if current else -1
    tree = ParseTree(NonTerminal(66, 'struct'))
    ctx.nonterminal = "struct"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 8: # $struct = :struct :identifier :lbrace $_gen2 :rbrace -> Struct( name=$1, entries=$3 )
        ctx.rule = rules[8]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('entries', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Struct', ast_parameters)
        t = expect(ctx, 44) # :struct
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen2(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[66] if x >=0],
      rules[8]
    )
def parse_struct_declaration(ctx):
    current = ctx.tokens.current()
    rule = table[21][current.id] if current else -1
    tree = ParseTree(NonTerminal(86, 'struct_declaration'))
    ctx.nonterminal = "struct_declaration"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 9: # $struct_declaration = $type_e :identifier -> StructEntry( type=$0, name=$1 )
        ctx.rule = rules[9]
        ast_parameters = OrderedDict([
            ('type', 0),
            ('name', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('StructEntry', ast_parameters)
        subtree = parse_type_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[86] if x >=0],
      rules[9]
    )
def parse_task(ctx):
    current = ctx.tokens.current()
    rule = table[29][current.id] if current else -1
    tree = ParseTree(NonTerminal(94, 'task'))
    ctx.nonterminal = "task"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 24: # $task = :task :identifier :lbrace $_gen7 :rbrace -> Task( name=$1, sections=$3 )
        ctx.rule = rules[24]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('sections', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Task', ast_parameters)
        t = expect(ctx, 18) # :task
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen7(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[94] if x >=0],
      rules[24]
    )
def parse_task_sections(ctx):
    current = ctx.tokens.current()
    rule = table[50][current.id] if current else -1
    tree = ParseTree(NonTerminal(115, 'task_sections'))
    ctx.nonterminal = "task_sections"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 25: # $task_sections = $command
        ctx.rule = rules[25]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_command(ctx)
        tree.add(subtree)
        return tree
    elif rule == 26: # $task_sections = $inputs
        ctx.rule = rules[26]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 27: # $task_sections = $outputs
        ctx.rule = rules[27]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 28: # $task_sections = $runtime
        ctx.rule = rules[28]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_runtime(ctx)
        tree.add(subtree)
        return tree
    elif rule == 29: # $task_sections = $parameter_meta
        ctx.rule = rules[29]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 30: # $task_sections = $meta
        ctx.rule = rules[30]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 31: # $task_sections = $declaration
        ctx.rule = rules[31]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[115] if x >=0],
      rules[31]
    )
def parse_version(ctx):
    current = ctx.tokens.current()
    rule = table[60][current.id] if current else -1
    tree = ParseTree(NonTerminal(125, 'version'))
    ctx.nonterminal = "version"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 6: # $version = :version :version_name -> VersionDeclaration( v=$1 )
        ctx.rule = rules[6]
        ast_parameters = OrderedDict([
            ('v', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('VersionDeclaration', ast_parameters)
        t = expect(ctx, 9) # :version
        tree.add(t)
        t = expect(ctx, 61) # :version_name
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[125] if x >=0],
      rules[6]
    )
def parse_wf_body_element(ctx):
    current = ctx.tokens.current()
    rule = table[38][current.id] if current else -1
    tree = ParseTree(NonTerminal(103, 'wf_body_element'))
    ctx.nonterminal = "wf_body_element"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 61: # $wf_body_element = $call
        ctx.rule = rules[61]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_call(ctx)
        tree.add(subtree)
        return tree
    elif rule == 62: # $wf_body_element = $declaration
        ctx.rule = rules[62]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_declaration(ctx)
        tree.add(subtree)
        return tree
    elif rule == 63: # $wf_body_element = $while_loop
        ctx.rule = rules[63]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_while_loop(ctx)
        tree.add(subtree)
        return tree
    elif rule == 64: # $wf_body_element = $if_stmt
        ctx.rule = rules[64]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_if_stmt(ctx)
        tree.add(subtree)
        return tree
    elif rule == 65: # $wf_body_element = $scatter
        ctx.rule = rules[65]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_scatter(ctx)
        tree.add(subtree)
        return tree
    elif rule == 66: # $wf_body_element = $inputs
        ctx.rule = rules[66]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_inputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 67: # $wf_body_element = $outputs
        ctx.rule = rules[67]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_outputs(ctx)
        tree.add(subtree)
        return tree
    elif rule == 68: # $wf_body_element = $wf_parameter_meta
        ctx.rule = rules[68]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_parameter_meta(ctx)
        tree.add(subtree)
        return tree
    elif rule == 69: # $wf_body_element = $wf_meta
        ctx.rule = rules[69]
        tree.astTransform = AstTransformSubstitution(0)
        subtree = parse_wf_meta(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[103] if x >=0],
      rules[69]
    )
def parse_wf_meta(ctx):
    current = ctx.tokens.current()
    rule = table[42][current.id] if current else -1
    tree = ParseTree(NonTerminal(107, 'wf_meta'))
    ctx.nonterminal = "wf_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 79: # $wf_meta = :meta $meta_map -> Meta( map=$1 )
        ctx.rule = rules[79]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('Meta', ast_parameters)
        t = expect(ctx, 15) # :meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[107] if x >=0],
      rules[79]
    )
def parse_wf_parameter_meta(ctx):
    current = ctx.tokens.current()
    rule = table[14][current.id] if current else -1
    tree = ParseTree(NonTerminal(79, 'wf_parameter_meta'))
    ctx.nonterminal = "wf_parameter_meta"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 78: # $wf_parameter_meta = :parameter_meta $meta_map -> ParameterMeta( map=$1 )
        ctx.rule = rules[78]
        ast_parameters = OrderedDict([
            ('map', 1),
        ])
        tree.astTransform = AstTransformNodeCreator('ParameterMeta', ast_parameters)
        t = expect(ctx, 11) # :parameter_meta
        tree.add(t)
        subtree = parse_meta_map(ctx)
        tree.add(subtree)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[79] if x >=0],
      rules[78]
    )
def parse_while_loop(ctx):
    current = ctx.tokens.current()
    rule = table[58][current.id] if current else -1
    tree = ParseTree(NonTerminal(123, 'while_loop'))
    ctx.nonterminal = "while_loop"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 80: # $while_loop = :while :lparen $e :rparen :lbrace $_gen15 :rbrace -> WhileLoop( expression=$2, body=$5 )
        ctx.rule = rules[80]
        ast_parameters = OrderedDict([
            ('expression', 2),
            ('body', 5),
        ])
        tree.astTransform = AstTransformNodeCreator('WhileLoop', ast_parameters)
        t = expect(ctx, 52) # :while
        tree.add(t)
        t = expect(ctx, 22) # :lparen
        tree.add(t)
        subtree = parse_e(ctx)
        tree.add(subtree)
        t = expect(ctx, 39) # :rparen
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[123] if x >=0],
      rules[80]
    )
def parse_workflow(ctx):
    current = ctx.tokens.current()
    rule = table[62][current.id] if current else -1
    tree = ParseTree(NonTerminal(127, 'workflow'))
    ctx.nonterminal = "workflow"
    if current == None:
        raise ctx.errors.unexpected_eof()
    if rule == 60: # $workflow = :workflow :identifier :lbrace $_gen15 :rbrace -> Workflow( name=$1, body=$3 )
        ctx.rule = rules[60]
        ast_parameters = OrderedDict([
            ('name', 1),
            ('body', 3),
        ])
        tree.astTransform = AstTransformNodeCreator('Workflow', ast_parameters)
        t = expect(ctx, 0) # :workflow
        tree.add(t)
        t = expect(ctx, 24) # :identifier
        tree.add(t)
        t = expect(ctx, 20) # :lbrace
        tree.add(t)
        subtree = parse__gen15(ctx)
        tree.add(subtree)
        t = expect(ctx, 7) # :rbrace
        tree.add(t)
        return tree
    raise ctx.errors.unexpected_symbol(
      ctx.nonterminal,
      ctx.tokens.current(),
      [terminals[x] for x in nonterminal_first[127] if x >=0],
      rules[60]
    )
# Lexer Code #
# START USER CODE
def init():
    return {
        'context': None,
        'replacements': {
            re.compile(r"\\n"): 0x000A,
            re.compile(r"\\r"): 0x000D,
            re.compile(r"\\b"): 0x0008,
            re.compile(r"\\t"): 0x0009,
            re.compile(r"\\a"): 0x0007,
            re.compile(r"\\v"): 0x000B,
            re.compile(r'\\"'): 0x0022,
            re.compile(r"\\'"): 0x0027,
            re.compile(r"\\\?"): 0x003F
        },
        'escapes': {
            re.compile(r'(\\([0-7]{1,3}))'): 8,
            re.compile(r'(\\[xX]([0-9a-fA-F]{1,4}))'): 16,
            re.compile(r'(\\[uU]([0-9a-fA-F]{4}))'): 16
        }
    }
def workflow(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'workflow'
    default_action(ctx, terminal, source_string, line, col)
def task(ctx, terminal, source_string, line, col):
    ctx.user_context['context'] = 'task'
    default_action(ctx, terminal, source_string, line, col)
def output(ctx, terminal, source_string, line, col):
    if ctx.user_context['context'] == 'workflow':
        ctx.stack.append('wf_output')
    default_action(ctx, terminal, source_string, line, col)
def wdl_unescape(ctx, terminal, source_string, line, col):
    for regex, c in ctx.user_context['replacements'].items():
        source_string = regex.sub(chr(c), source_string)
    source_string = source_string.replace("\u005C\u005C", "\u005C")
    for regex, base in ctx.user_context['escapes'].items():
        for escape_sequence, number in regex.findall(source_string):
            source_string = source_string.replace(escape_sequence, chr(int(number, base)))
    default_action(ctx, terminal, source_string, line, col)
# END USER CODE
def emit(ctx, terminal, source_string, line, col):
    if terminal:
        ctx.tokens.append(Terminal(terminals[terminal], terminal, source_string, ctx.resource, line, col))
def default_action(ctx, terminal, source_string, line, col):
    emit(ctx, terminal, source_string, line, col)
def post_filter(tokens):
    return tokens
def destroy(context):
    pass
class LexerStackPush:
    def __init__(self, mode):
        self.mode = mode
class LexerAction:
    def __init__(self, action):
        self.action = action
class LexerContext:
    def __init__(self, string, resource, errors, user_context):
        self.__dict__.update(locals())
        self.stack = ['default']
        self.line = 1
        self.col = 1
        self.tokens = []
        self.user_context = user_context
        self.re_match = None # https://docs.python.org/3/library/re.html#match-objects
class HermesLexer:
    regex = {
        'default': OrderedDict([
          (re.compile(r'#.*'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'^version(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('version', 0, None),
              LexerStackPush('awaiting_version_name'),
          ]),
        ]),
        'main': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'/\*(.*?)\*/', re.DOTALL), [
              # (terminal, group, function)
          ]),
          (re.compile(r'#.*'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'task(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('task', 0, task),
          ]),
          (re.compile(r'(call)\s+'), [
              # (terminal, group, function)
              ('call', 1, None),
              LexerStackPush('task_fqn'),
          ]),
          (re.compile(r'workflow(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('workflow', 0, workflow),
          ]),
          (re.compile(r'struct(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('struct', 0, None),
          ]),
          (re.compile(r'import(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('import', 0, None),
          ]),
          (re.compile(r'alias(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('alias', 0, None),
          ]),
          (re.compile(r'input(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('input', 0, None),
          ]),
          (re.compile(r'output(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('output', 0, None),
          ]),
          (re.compile(r'as(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('as', 0, None),
          ]),
          (re.compile(r'if(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'then(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'else(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'runtime(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('runtime', 0, None),
          ]),
          (re.compile(r'scatter(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('scatter', 0, None),
              LexerStackPush('scatter'),
          ]),
          (re.compile(r'command\s*(?=<<<)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command2'),
          ]),
          (re.compile(r'command\s*(?=\{)'), [
              # (terminal, group, function)
              ('raw_command', 0, None),
              LexerStackPush('raw_command'),
          ]),
          (re.compile(r'parameter_meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('parameter_meta', 0, None),
          ]),
          (re.compile(r'meta(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('meta', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(object)\s*(\{)'), [
              # (terminal, group, function)
              ('object', 0, None),
              ('lbrace', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r'null'), [
              # (terminal, group, function)
              ('null', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('rbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'\?'), [
              # (terminal, group, function)
              ('qmark', 0, None),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
        'dquote_string': OrderedDict([
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'[^\"\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, wdl_unescape),
          ]),
        ]),
        'squote_string': OrderedDict([
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'[^\'\n(\$\{)(~\{)]*'), [
              # (terminal, group, function)
              ('string', 0, wdl_unescape),
          ]),
        ]),
        'awaiting_version_name': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'1.0'), [
              # (terminal, group, function)
              ('version_name', 0, None),
              LexerStackPush('main'),
          ]),
        ]),
        'task_fqn': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(\.[a-zA-Z]([a-zA-Z0-9_])*)*'), [
              # (terminal, group, function)
              ('fqn', 0, None),
              LexerAction('pop'),
          ]),
        ]),
        'scatter': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'in(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('in', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
        ]),
        'raw_command': OrderedDict([
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\$\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=\$\{|~\{|\})', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'raw_command2': OrderedDict([
          (re.compile(r'<<<'), [
              # (terminal, group, function)
              ('raw_cmd_start', 0, None),
          ]),
          (re.compile(r'>>>'), [
              # (terminal, group, function)
              ('raw_cmd_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'~\{'), [
              # (terminal, group, function)
              ('expression_placeholder_start', 0, None),
              LexerStackPush('expression_placeholder'),
          ]),
          (re.compile(r'(.*?)(?=~\{|>>>)', re.DOTALL), [
              # (terminal, group, function)
              ('cmd_part', 0, None),
          ]),
        ]),
        'expression_placeholder': OrderedDict([
          (re.compile(r'\s+'), [
              # (terminal, group, function)
          ]),
          (re.compile(r'\}'), [
              # (terminal, group, function)
              ('expression_placeholder_end', 0, None),
              LexerAction('pop'),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
          (re.compile(r'if'), [
              # (terminal, group, function)
              ('if', 0, None),
          ]),
          (re.compile(r'else'), [
              # (terminal, group, function)
              ('else', 0, None),
          ]),
          (re.compile(r'then'), [
              # (terminal, group, function)
              ('then', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*(?=\s*=)'), [
              # (terminal, group, function)
              ('cmd_attr_hint', None, None),
              ('identifier', 0, None),
          ]),
          (re.compile(r'(true|false)(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('boolean', 0, None),
          ]),
          (re.compile(r'(Array|Map|Object|Pair|Boolean|Int|Float|Uri|File|String)(?![a-zA-Z0-9_])(?![a-zA-Z0-9_])'), [
              # (terminal, group, function)
              ('type', 0, None),
          ]),
          (re.compile(r'[a-zA-Z]([a-zA-Z0-9_])*'), [
              # (terminal, group, function)
              ('identifier', 0, None),
          ]),
          (re.compile(r':'), [
              # (terminal, group, function)
              ('colon', 0, None),
          ]),
          (re.compile(r','), [
              # (terminal, group, function)
              ('comma', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'=='), [
              # (terminal, group, function)
              ('double_equal', 0, None),
          ]),
          (re.compile(r'\|\|'), [
              # (terminal, group, function)
              ('double_pipe', 0, None),
          ]),
          (re.compile(r'\&\&'), [
              # (terminal, group, function)
              ('double_ampersand', 0, None),
          ]),
          (re.compile(r'!='), [
              # (terminal, group, function)
              ('not_equal', 0, None),
          ]),
          (re.compile(r'='), [
              # (terminal, group, function)
              ('equal', 0, None),
          ]),
          (re.compile(r'\.'), [
              # (terminal, group, function)
              ('dot', 0, None),
          ]),
          (re.compile(r'\{'), [
              # (terminal, group, function)
              ('lbrace', 0, None),
          ]),
          (re.compile(r'\('), [
              # (terminal, group, function)
              ('lparen', 0, None),
          ]),
          (re.compile(r'\)'), [
              # (terminal, group, function)
              ('rparen', 0, None),
          ]),
          (re.compile(r'\['), [
              # (terminal, group, function)
              ('lsquare', 0, None),
          ]),
          (re.compile(r'\]'), [
              # (terminal, group, function)
              ('rsquare', 0, None),
          ]),
          (re.compile(r'\+'), [
              # (terminal, group, function)
              ('plus', 0, None),
          ]),
          (re.compile(r'\*'), [
              # (terminal, group, function)
              ('asterisk', 0, None),
          ]),
          (re.compile(r'-'), [
              # (terminal, group, function)
              ('dash', 0, None),
          ]),
          (re.compile(r'/'), [
              # (terminal, group, function)
              ('slash', 0, None),
          ]),
          (re.compile(r'%'), [
              # (terminal, group, function)
              ('percent', 0, None),
          ]),
          (re.compile(r'<='), [
              # (terminal, group, function)
              ('lteq', 0, None),
          ]),
          (re.compile(r'<'), [
              # (terminal, group, function)
              ('lt', 0, None),
          ]),
          (re.compile(r'>='), [
              # (terminal, group, function)
              ('gteq', 0, None),
          ]),
          (re.compile(r'>'), [
              # (terminal, group, function)
              ('gt', 0, None),
          ]),
          (re.compile(r'!'), [
              # (terminal, group, function)
              ('not', 0, None),
          ]),
          (re.compile(r'\"'), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('dquote_string'),
          ]),
          (re.compile(r'\''), [
              # (terminal, group, function)
              ('quote', 0, None),
              LexerStackPush('squote_string'),
          ]),
          (re.compile(r'-?[0-9]+\.[0-9]+'), [
              # (terminal, group, function)
              ('float', 0, None),
          ]),
          (re.compile(r'[0-9]+'), [
              # (terminal, group, function)
              ('integer', 0, None),
          ]),
        ]),
    }
    def _advance_line_col(self, string, length, line, col):
        for i in range(length):
            if string[i] == '\n':
                line += 1
                col = 1
            else:
                col += 1
        return (line, col)
    def _advance_string(self, ctx, string):
        (ctx.line, ctx.col) = self._advance_line_col(string, len(string), ctx.line, ctx.col)
        ctx.string = ctx.string[len(string):]
    def _next(self, ctx, debug=False):
        for regex, outputs in self.regex[ctx.stack[-1]].items():
            if debug:
                from xtermcolor import colorize
                token_count = len(ctx.tokens)
                print('{1} ({2}, {3}) regex: {0}'.format(
                    colorize(regex.pattern, ansi=40), colorize(ctx.string[:20].replace('\n', '\\n'), ansi=15), ctx.line, ctx.col)
                )
            match = regex.match(ctx.string)
            if match:
                ctx.re_match = match
                for output in outputs:
                    if isinstance(output, tuple):
                        (terminal, group, function) = output
                        function = function if function else default_action
                        source_string = match.group(group) if group is not None else ''
                        (group_line, group_col) = self._advance_line_col(ctx.string, match.start(group) if group else 0, ctx.line, ctx.col)
                        function(
                            ctx,
                            terminal,
                            source_string,
                            group_line,
                            group_col
                        )
                        if debug:
                            print('    matched: {}'.format(colorize(match.group(0).replace('\n', '\\n'), ansi=3)))
                            for token in ctx.tokens[token_count:]:
                                print('    emit: [{}] [{}, {}] [{}] stack:{} context:{}'.format(
                                    colorize(token.str, ansi=9),
                                    colorize(str(token.line), ansi=5),
                                    colorize(str(token.col), ansi=5),
                                    colorize(token.source_string, ansi=3),
                                    colorize(str(ctx.stack), ansi=4),
                                    colorize(str(ctx.user_context), ansi=13)
                                ))
                            token_count = len(ctx.tokens)
                    if isinstance(output, LexerStackPush):
                        ctx.stack.append(output.mode)
                        if debug:
                            print('    push on stack: {}'.format(colorize(output.mode, ansi=4)))
                    if isinstance(output, LexerAction):
                        if output.action == 'pop':
                            mode = ctx.stack.pop()
                            if debug:
                                print('    pop off stack: {}'.format(colorize(mode, ansi=4)))
                self._advance_string(ctx, match.group(0))
                return len(match.group(0)) > 0
        return False
    def lex(self, string, resource, errors=None, debug=False):
        if errors is None:
            errors = DefaultSyntaxErrorHandler()
        string_copy = string
        user_context = init()
        ctx = LexerContext(string, resource, errors, user_context)
        while len(ctx.string):
            matched = self._next(ctx, debug)
            if matched == False:
                raise ctx.errors.unrecognized_token(string_copy, ctx.line, ctx.col)
        destroy(ctx.user_context)
        filtered = post_filter(ctx.tokens)
        return filtered
def lex(source, resource, errors=None, debug=False):
    return TokenStream(HermesLexer().lex(source, resource, errors, debug))
